/*! Flocking 3.0.1, Copyright 2022 Colin Clark | flockingjs.org */
"use strict";

!function() {
    var e = "undefined" != typeof window ? window : "undefined" != typeof self ? self : "undefined" != typeof module && module.exports ? module.exports : global;
    e.ArrayMath || (e.ArrayMath = {
        add: function(e, t, n) {
            var o;
            if (t instanceof Float32Array) for (o = Math.min(e.length, t.length, n.length) - 1; 0 <= o; --o) e[o] = t[o] + n[o]; else for (o = Math.min(e.length, n.length) - 1; 0 <= o; --o) e[o] = t + n[o];
        },
        sub: function(e, t, n) {
            var o;
            if (t instanceof Float32Array) for (o = Math.min(e.length, t.length, n.length) - 1; 0 <= o; --o) e[o] = t[o] - n[o]; else for (o = Math.min(e.length, n.length) - 1; 0 <= o; --o) e[o] = t - n[o];
        },
        mul: function(e, t, n) {
            var o;
            if (t instanceof Float32Array) for (o = Math.min(e.length, t.length, n.length) - 1; 0 <= o; --o) e[o] = t[o] * n[o]; else for (o = Math.min(e.length, n.length) - 1; 0 <= o; --o) e[o] = t * n[o];
        },
        mulCplx: function(e, t, n, o, r, a) {
            var i, l, u, s, f;
            if (n instanceof Float32Array) for (i = Math.min(e.length, t.length, n.length, o.length, r.length, a.length) - 1; 0 <= i; --i) l = n[i], 
            u = o[i], s = r[i], f = a[i], e[i] = l * s - u * f, t[i] = l * f + u * s; else for (i = Math.min(e.length, t.length, r.length, a.length) - 1; 0 <= i; --i) s = r[i], 
            f = a[i], e[i] = n * s - o * f, t[i] = n * f + o * s;
        },
        div: function(e, t, n) {
            var o;
            if (t instanceof Float32Array) for (o = Math.min(e.length, t.length, n.length) - 1; 0 <= o; --o) e[o] = t[o] / n[o]; else for (o = Math.min(e.length, n.length) - 1; 0 <= o; --o) e[o] = t / n[o];
        },
        divCplx: function(e, t, n, o, r, a) {
            var i, l, u, s, f, c;
            if (n instanceof Float32Array) for (i = Math.min(e.length, t.length, n.length, o.length, r.length, a.length) - 1; 0 <= i; --i) l = n[i], 
            u = o[i], s = r[i], f = a[i], e[i] = (l * s + u * f) * (c = 1 / (s * s + f * f)), 
            t[i] = (u * s - l * f) * c; else for (i = Math.min(e.length, t.length, r.length, a.length) - 1; 0 <= i; --i) s = r[i], 
            f = a[i], e[i] = (n * s + o * f) * (c = 1 / (s * s + f * f)), t[i] = (o * s - n * f) * c;
        },
        madd: function(e, t, n, o) {
            var r;
            if (t instanceof Float32Array) for (r = Math.min(e.length, t.length, n.length, o.length) - 1; 0 <= r; --r) e[r] = t[r] * n[r] + o[r]; else for (r = Math.min(e.length, n.length, o.length) - 1; 0 <= r; --r) e[r] = t * n[r] + o[r];
        },
        abs: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.abs(t[n]);
        },
        absCplx: function(e, t, n) {
            for (var o = Math.min(e.length, t.length, n.length) - 1; 0 <= o; --o) e[o] = Math.sqrt(t[o] * t[o] + n[o] * n[o]);
        },
        acos: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.acos(t[n]);
        },
        asin: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.asin(t[n]);
        },
        atan: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.atan(t[n]);
        },
        atan2: function(e, t, n) {
            for (var o = Math.min(e.length, n.length, t.length) - 1; 0 <= o; --o) e[o] = Math.atan2(t[o], n[o]);
        },
        ceil: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.ceil(t[n]);
        },
        cos: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.cos(t[n]);
        },
        exp: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.exp(t[n]);
        },
        floor: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.floor(t[n]);
        },
        log: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.log(t[n]);
        },
        max: function(e) {
            for (var t = -1 / 0, n = e.length - 1; 0 <= n; --n) {
                var o = e[n];
                t < o && (t = o);
            }
            return t;
        },
        min: function(e) {
            for (var t = 1 / 0, n = e.length - 1; 0 <= n; --n) {
                var o = e[n];
                o < t && (t = o);
            }
            return t;
        },
        pow: function(e, t, n) {
            var o;
            if (n instanceof Float32Array) for (o = Math.min(e.length, t.length, n.length) - 1; 0 <= o; --o) e[o] = Math.pow(t[o], n[o]); else for (o = Math.min(e.length, t.length) - 1; 0 <= o; --o) e[o] = Math.pow(t[o], n);
        },
        random: function(e, t, n) {
            t = t || 0;
            for (var o = (n = isNaN(parseFloat(n)) ? 1 : n) - t, r = e.length - 1; 0 <= r; --r) e[r] = Math.random() * o + t;
        },
        round: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.round(t[n]);
        },
        sin: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.sin(t[n]);
        },
        sqrt: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.sqrt(t[n]);
        },
        tan: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = Math.tan(t[n]);
        },
        clamp: function(e, t, n, o) {
            for (var r = Math.min(e.length, t.length) - 1; 0 <= r; --r) {
                var a = t[r];
                e[r] = a < n ? n : o < a ? o : a;
            }
        },
        fract: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) {
                var o = t[n];
                e[n] = o - Math.floor(o);
            }
        },
        fill: function(e, t) {
            for (var n = e.length - 1; 0 <= n; --n) e[n] = t;
        },
        ramp: function(e, t, n) {
            var o = e.length - 1;
            if (0 <= o && (e[0] = t), 0 < o) for (var r = (n - t) / o, a = 1; a <= o; ++a) e[a] = t + r * a;
        },
        sign: function(e, t) {
            for (var n = Math.min(e.length, t.length) - 1; 0 <= n; --n) e[n] = t[n] < 0 ? -1 : 1;
        },
        sum: function(e) {
            for (var t = 0, n = e.length - 1; 0 <= n; --n) t += e[n];
            return t;
        },
        sampleLinear: function(e, t, n) {
            for (var o = t.length - 1, r = Math.min(e.length, n.length) - 1; 0 <= r; --r) {
                var a = (a = n[r]) < 0 ? 0 : o < a ? o : a, i = Math.floor(a), l = t[i], u = t[i < o ? i + 1 : o];
                e[r] = l + (a - i) * (u - l);
            }
        },
        sampleLinearRepeat: function(e, t, n) {
            for (var o = t.length, r = o - 1, a = Math.min(e.length, n.length) - 1; 0 <= a; --a) {
                var i = n[a], l = (i -= Math.floor(i / o) * o, Math.floor(i)), u = t[l], s = t[l < r ? l + 1 : 0];
                e[a] = u + (i - l) * (s - u);
            }
        },
        sampleCubic: function(e, t, n) {
            for (var o = t.length - 1, r = Math.min(e.length, n.length) - 1; 0 <= r; --r) {
                var a = (a = n[r]) < 0 ? 0 : o < a ? o : a, i = Math.floor(a), a = a - i, l = a * a, u = l * a, s = -2 * u + 3 * l, u = u - l, f = t[0 < i ? i - 1 : 0], c = t[i], d = t[i < o ? i + 1 : o], i = t[i < o - 1 ? i + 2 : o];
                e[r] = (1 - s) * c + s * d + .5 * ((u - l + a) * (d - f) + u * (i - c));
            }
        },
        sampleCubicRepeat: function(e, t, n) {
            for (var o = t.length, r = o - 1, a = Math.min(e.length, n.length) - 1; 0 <= a; --a) {
                var i = n[a], l = (i -= Math.floor(i / o) * o, Math.floor(i)), i = i - l, u = i * i, s = u * i, f = -2 * s + 3 * u, c = 1 - f, s = s - u, u = s - u + i, i = t[0 < l ? l - 1 : r], d = t[l], h = t[l < r ? l + 1 : 0], l = t[l < r - 1 ? l + 2 : l + 2 - Math.floor((l + 2) / o) * o];
                e[a] = c * d + f * h + .5 * (u * (h - i) + s * (l - d));
            }
        },
        pack: function(e, t, n, o, r, a, i) {
            var l = Math.floor(Math.max(0, e.length - t) / n), u = Math.min(l, o.length);
            if (r) {
                u = Math.min(u, r.length);
                if (a) {
                    u = Math.min(u, a.length);
                    if (i) for (var u = Math.min(u, i.length), s = 0; s < u; ++s) e[t] = o[s], 
                    e[t + 1] = r[s], e[t + 2] = a[s], e[t + 3] = i[s], t += n; else for (s = 0; s < u; ++s) e[t] = o[s], 
                    e[t + 1] = r[s], e[t + 2] = a[s], t += n;
                } else for (s = 0; s < u; ++s) e[t] = o[s], e[t + 1] = r[s], t += n;
            } else for (s = 0; s < u; ++s) e[t] = o[s], t += n;
        },
        unpack: function(e, t, n, o, r, a, i) {
            var l = Math.floor(Math.max(0, e.length - t) / n), u = Math.min(l, o.length);
            if (r) {
                u = Math.min(u, r.length);
                if (a) {
                    u = Math.min(u, a.length);
                    if (i) for (var u = Math.min(u, i.length), s = 0; s < u; ++s) o[s] = e[t], 
                    r[s] = e[t + 1], a[s] = e[t + 2], i[s] = e[t + 3], t += n; else for (s = 0; s < u; ++s) o[s] = e[t], 
                    r[s] = e[t + 1], a[s] = e[t + 2], t += n;
                } else for (s = 0; s < u; ++s) o[s] = e[t], r[s] = e[t + 1], t += n;
            } else for (s = 0; s < u; ++s) o[s] = e[t], t += n;
        }
    });
}(), function() {
    var e, t = "undefined" != typeof window ? window : "undefined" != typeof self ? self : "undefined" != typeof module && module.exports ? module.exports : global;
    t.Filter || ((e = function(e, t) {
        !isNaN(parseFloat(e)) && isFinite(e) || (e = 1), t = t || 0, this._b = new Float32Array(e), 
        this._b[0] = 1, this._a = new Float32Array(t), this._bHist = new Float32Array(e), 
        this._aHist = new Float32Array(t);
    }).prototype.filter = function(e, t) {
        for (var n = this._a, o = n.length, r = this._b, a = r.length, i = this._aHist, l = this._bHist, u = t.length, s = e.length, f = a - 1, c = o, d = 0; (f || c) && d < u; ++d) {
            var h = a - f, m = (f && f--, r[0] * t[d]);
            for (C = 1; C < h; ++C) m += r[C] * t[d - C];
            for (;C < a; ++C) m += r[C] * l[C - h];
            for (h = o - c, c && c--, C = 0; C < h; ++C) m -= n[C] * e[d - 1 - C];
            for (;C < o; ++C) m -= n[C] * i[C - h];
            e[d] = m;
        }
        if (3 == a && 2 == o) for (var p, g, k = r[0], v = r[1], b = r[2], y = n[0], w = n[1], N = t[d - 1], A = t[d - 2], M = e[d - 1], S = e[d - 2]; d < u; ++d) p = A, 
        A = N, N = t[d], g = S, S = M, e[d] = M = k * N + v * A + b * p - y * S - w * g; else for (;d < u; ++d) {
            var C, m = r[0] * t[d];
            for (C = 1; C < a; ++C) m += r[C] * t[d - C];
            for (C = 0; C < o; ++C) m -= n[C] * e[d - 1 - C];
            e[d] = m;
        }
        var I = Math.min(a - 1, u);
        for (d = a - 2; I <= d; --d) l[d] = l[d - I];
        for (d = 0; d < I; ++d) l[d] = t[u - 1 - d];
        for (I = Math.min(o, s), d = o - 1; I <= d; --d) i[d] = i[d - I];
        for (d = 0; d < I; ++d) i[d] = e[u - 1 - d];
    }, e.prototype.clearHistory = function() {
        for (var e = this._bHist.length - 1; 0 <= e; --e) this._bHist[e] = 0;
        for (e = this._aHist.length - 1; 0 <= e; --e) this._aHist[e] = 0;
    }, e.prototype.setB = function(e) {
        for (var t = Math.min(this._b.length, e.length), n = 0; n < t; ++n) this._b[n] = e[n];
    }, e.prototype.setA = function(e) {
        for (var t = Math.min(this._a.length, e.length), n = 0; n < t; ++n) this._a[n] = e[n];
    }, t.Filter = e);
}(), function() {
    var Ht, e, t = "undefined" != typeof window ? window : "undefined" != typeof self ? self : "undefined" != typeof module && module.exports ? module.exports : global;
    t.FFT || (Ht = function(e, t, n, R, E, V, o, U, G, _, W, q, z, j) {
        var H = G[_++], r = G[_++], K = n, Q = n + H * r, X = o * U;
        if (1 == r) for (;e[n] = R[V], t[n] = E[V], V += X, ++n != Q; ); else for (;Ht(e, t, n, R, E, V, o * H, U, G, _, W, q, z, j), 
        V += X, (n += r) != Q; );
        switch (n = K, H) {
          case 2:
            for (var J, Y, $, Z, ee, te, ne, oe = e, re = t, ae = o, ie = W, le = q, ue = 0, a = n, se = n + r, fe = .7071067811865475, ce = a + r; a < ce; ) Y = oe[a] * fe, 
            $ = re[a] * fe, Z = oe[se] * fe, ee = re[se] * fe, te = ie[ue], J = Z * (ne = le[ue]) + ee * te, 
            oe[se] = Y - (Z = Z * te - ee * ne), re[se] = $ - J, oe[a] = Y + Z, 
            re[a] = $ + J, ue += ae, ++a, ++se;
            break;

          case 3:
            for (var de, he, me, pe, ge, ke, ve, be, ye, we, i, l, Ne = e, Ae = t, Me = o, Se = W, Ce = q, u = r, Ie = 0, Le = 0, De = 2 * Me, s = n, xe = n + u, Fe = n + 2 * u, Oe = Ce[Me * u], Te = .5773502691896258, Be = s + u; s < Be; ) ge = Ne[s] * Te, 
            ke = Ae[s] * Te, ve = Ne[xe] * Te, be = Ae[xe] * Te, ye = Ne[Fe] * Te, 
            we = Ae[Fe] * Te, i = Se[Ie], me = ve * (l = Ce[Ie]) + be * i, de = (he = ve * i - be * l) - (pe = ye * (i = Se[Le]) - we * (l = Ce[Le])), 
            l = me - (ye = ye * l + we * i), ve = ge - .5 * (we = he + pe), be = ke - .5 * (i = me + ye), 
            de *= Oe, l *= Oe, Ne[s] = ge + we, Ae[s] = ke + i, Ne[Fe] = ve + l, 
            Ae[Fe] = be - de, Ne[xe] = ve - l, Ae[xe] = be + de, Ie += Me, Le += De, 
            ++s, ++xe, ++Fe;
            break;

          case 4:
            for (var Pe, Re, Ee, Ve, Ue, Ge, _e, f, c, We, d, h, m, p = e, g = t, qe = o, ze = W, je = q, He = j, Ke = 0, Qe = 0, Xe = 0, Je = 2 * qe, Ye = 3 * qe, k = n, v = n + r, $e = n + 2 * r, b = n + 3 * r, Ze = k + r; k < Ze; ) Ve = .5 * p[k], 
            Ue = .5 * g[k], Ge = .5 * p[v], _e = .5 * g[v], f = .5 * p[$e], c = .5 * g[$e], 
            We = .5 * p[b], d = .5 * g[b], Pe = Ge * (h = ze[Ke]) - _e * (m = je[Ke]), 
            Ge = Ge * m + _e * h, _e = f * (h = ze[Qe]) - c * (m = je[Qe]), f = f * m + c * h, 
            h = ze[Xe], c = Ve - _e, Ee = Ue - f, Ue += f, Re = Ge + (f = We * (m = je[Xe]) + d * h), 
            h = Pe - (We = We * h - d * m), d = Ge - f, p[$e] = (Ve += _e) - (m = Pe + We), 
            g[$e] = Ue - Re, p[k] = Ve + m, g[k] = Ue + Re, He ? (p[v] = c - d, 
            g[v] = Ee + h, p[b] = c + d, g[b] = Ee - h) : (p[v] = c + d, g[v] = Ee - h, 
            p[b] = c - d, g[b] = Ee + h), Ke += qe, Qe += Je, Xe += Ye, ++k, ++v, 
            ++$e, ++b;
            break;

          case 5:
            for (var et, tt, y, nt, ot, w, N, A, M, S, C, I, rt, L, D, x = e, F = t, O = o, at = W, it = q, u = r, lt = 0, ut = 0, st = 0, ft = 0, ct = 2 * O, dt = 3 * O, ht = 4 * O, T = n, mt = n + u, pt = n + 2 * u, gt = n + 3 * u, kt = n + 4 * u, vt = at[O * u], bt = it[O * u], yt = at[2 * O * u], wt = it[2 * O * u], B = .4472135954999579, Nt = T + u; T < Nt; ) nt = x[T] * B, 
            ot = F[T] * B, w = x[mt] * B, N = F[mt] * B, A = x[pt] * B, M = F[pt] * B, 
            S = x[gt] * B, C = F[gt] * B, I = x[kt] * B, rt = F[kt] * B, et = ot, 
            y = w * (L = at[lt]) - N * (D = it[lt]), w = w * D + N * L, N = A * (L = at[ut]) - M * (D = it[ut]), 
            A = A * D + M * L, M = S * (L = at[st]) - C * (D = it[st]), S = S * D + C * L, 
            L = at[ft], tt = w + (C = I * (D = it[ft]) + rt * L), L = y - (I = I * L - rt * D), 
            rt = w - C, D = A + S, w = N - M, C = A - S, x[T] = (A = nt) + (S = y + I) + (nt = N + M), 
            F[T] = ot + tt + D, y = et + tt * vt + D * yt, I = -L * bt - w * wt, 
            x[mt] = (N = A + S * vt + nt * yt) - (M = rt * bt + C * wt), F[mt] = y - I, 
            x[kt] = N + M, F[kt] = y + I, ot = et + tt * yt + D * vt, N = L * wt - w * bt, 
            x[pt] = (M = A + S * yt + nt * vt) + (y = -rt * wt + C * bt), F[pt] = ot + N, 
            x[gt] = M - y, F[gt] = ot - N, lt += O, ut += ct, st += dt, ft += ht, 
            ++T, ++mt, ++pt, ++gt, ++kt;
            break;

          default:
            for (var At, Mt, St, Ct, It = e, Lt = t, Dt = n, xt = o, Ft = W, Ot = q, Tt = r, Bt = H, Pt = z, Rt = new Float32Array(Bt), Et = new Float32Array(Bt), Vt = Math.sqrt(1 / Bt), Ut = 0; Ut < Tt; ++Ut) {
                for (P = Dt + Ut, _t = 0; _t < Bt; ++_t) Rt[_t] = It[P] * Vt, Et[_t] = Lt[P] * Vt, 
                P += Tt;
                for (var P = Dt + Ut, Gt = xt * Ut, _t = 0; _t < Bt; ++_t) {
                    for (var Wt = Rt[0], qt = Et[0], zt = 0, jt = 1; jt < Bt; ++jt) Pt <= (zt += Gt) && (zt -= Pt), 
                    At = Rt[jt], Mt = Et[jt], Wt += At * (St = Ft[zt]) - Mt * (Ct = Ot[zt]), 
                    qt += At * Ct + Mt * St;
                    It[P] = Wt, Lt[P] = qt, P += Tt, Gt += xt;
                }
            }
        }
    }, (e = function(e) {
        e = e || 256, Object.defineProperty(this, "size", {
            configurable: !1,
            writable: !1,
            value: e
        }), this._twiddlesFwdRe = new Float32Array(e), this._twiddlesFwdIm = new Float32Array(e), 
        this._twiddlesInvRe = this._twiddlesFwdRe, this._twiddlesInvIm = new Float32Array(e);
        for (var t = 0; t < e; ++t) {
            var n = -2 * Math.PI * t / e, o = Math.cos(n), n = Math.sin(n);
            this._twiddlesFwdRe[t] = o, this._twiddlesFwdIm[t] = n, this._twiddlesInvIm[t] = -n;
        }
        this._factors = new Int32Array(64);
        var r = e, a = this._factors, i = 4, l = Math.floor(Math.sqrt(r)), u = 0;
        do {
            for (;r % i; ) {
                switch (i) {
                  case 4:
                    i = 2;
                    break;

                  case 2:
                    i = 3;
                    break;

                  default:
                    i += 2;
                }
                l < i && (i = r);
            }
        } while (r = Math.floor(r / i), a[u++] = i, 1 < (a[u++] = r));
    }).prototype.forwardCplx = function(e, t, n, o) {
        var r = this._twiddlesFwdRe, a = this._twiddlesFwdIm;
        Ht(e, t, 0, n, o, 0, 1, 1, this._factors, 0, r, a, this.size, !1);
    }, e.prototype.forward = function(e, t, n) {
        this.forwardCplx(e, t, n, new Float32Array(this.size));
    }, e.prototype.inverseCplx = function(e, t, n, o) {
        var r = this._twiddlesInvRe, a = this._twiddlesInvIm;
        Ht(e, t, 0, n, o, 0, 1, 1, this._factors, 0, r, a, this.size, !0);
    }, e.prototype.inverse = function(e, t, n) {
        this.inverseCplx(e, new Float32Array(this.size), t, n);
    }, t.FFT = e);
}();

{
    {
        var Random = function(e) {
            if ("number" != typeof (e = void 0 === e ? new Date().getTime() : e) || Math.ceil(e) != Math.floor(e)) throw new TypeError("seed value must be an integer");
            this.N = 624, this.M = 397, this.MATRIX_A = 2567483615, this.UPPER_MASK = 2147483648, 
            this.LOWER_MASK = 2147483647, this.mt = new Array(this.N), this.mti = this.N + 1, 
            this.init_by_array([ e ], 1);
        }, fluid = (Random.prototype.init_genrand = function(e) {
            for (this.mt[0] = e >>> 0, this.mti = 1; this.mti < this.N; this.mti++) {
                e = this.mt[this.mti - 1] ^ this.mt[this.mti - 1] >>> 30;
                this.mt[this.mti] = (1812433253 * ((4294901760 & e) >>> 16) << 16) + 1812433253 * (65535 & e) + this.mti, 
                this.mt[this.mti] >>>= 0;
            }
        }, Random.prototype.init_by_array = function(e, t) {
            var n, o, r;
            for (this.init_genrand(19650218), n = 1, o = 0, r = this.N > t ? this.N : t; r; r--) {
                var a = this.mt[n - 1] ^ this.mt[n - 1] >>> 30;
                this.mt[n] = (this.mt[n] ^ (1664525 * ((4294901760 & a) >>> 16) << 16) + 1664525 * (65535 & a)) + e[o] + o, 
                this.mt[n] >>>= 0, o++, ++n >= this.N && (this.mt[0] = this.mt[this.N - 1], 
                n = 1), t <= o && (o = 0);
            }
            for (r = this.N - 1; r; r--) {
                a = this.mt[n - 1] ^ this.mt[n - 1] >>> 30;
                this.mt[n] = (this.mt[n] ^ (1566083941 * ((4294901760 & a) >>> 16) << 16) + 1566083941 * (65535 & a)) - n, 
                this.mt[n] >>>= 0, ++n >= this.N && (this.mt[0] = this.mt[this.N - 1], 
                n = 1);
            }
            this.mt[0] = 2147483648;
        }, Random.prototype.genrand_int32 = function() {
            var e, t, n = new Array(0, this.MATRIX_A);
            if (this.mti >= this.N) {
                for (this.mti == this.N + 1 && this.init_genrand(5489), t = 0; t < this.N - this.M; t++) e = this.mt[t] & this.UPPER_MASK | this.mt[t + 1] & this.LOWER_MASK, 
                this.mt[t] = this.mt[t + this.M] ^ e >>> 1 ^ n[1 & e];
                for (;t < this.N - 1; t++) e = this.mt[t] & this.UPPER_MASK | this.mt[t + 1] & this.LOWER_MASK, 
                this.mt[t] = this.mt[t + (this.M - this.N)] ^ e >>> 1 ^ n[1 & e];
                e = this.mt[this.N - 1] & this.UPPER_MASK | this.mt[0] & this.LOWER_MASK, 
                this.mt[this.N - 1] = this.mt[this.M - 1] ^ e >>> 1 ^ n[1 & e], 
                this.mti = 0;
            }
            return e = this.mt[this.mti++], (e = (e = (e = (e ^= e >>> 11) ^ e << 7 & 2636928640) ^ e << 15 & 4022730752) ^ e >>> 18) >>> 0;
        }, Random.prototype.genrand_int31 = function() {
            return this.genrand_int32() >>> 1;
        }, Random.prototype.genrand_real1 = function() {
            return this.genrand_int32() * (1 / 4294967295);
        }, Random.prototype.random = function() {
            return this.pythonCompatibility && (this.skip && this.genrand_int32(), 
            this.skip = !0), this.genrand_int32() * (1 / 4294967296);
        }, Random.prototype.genrand_real3 = function() {
            return (this.genrand_int32() + .5) * (1 / 4294967296);
        }, Random.prototype.genrand_res53 = function() {
            return 1 / 9007199254740992 * (67108864 * (this.genrand_int32() >>> 5) + (this.genrand_int32() >>> 6));
        }, Random.prototype.LOG4 = Math.log(4), Random.prototype.SG_MAGICCONST = 1 + Math.log(4.5), 
        Random.prototype.exponential = function(e) {
            if (1 != arguments.length) throw new SyntaxError("exponential() must  be called with 'lambda' parameter");
            var t = this.random();
            return -Math.log(t) / e;
        }, Random.prototype.gamma = function(e, t) {
            if (2 != arguments.length) throw new SyntaxError("gamma() must be called with alpha and beta parameters");
            if (!(1 < e)) {
                if (1 == e) {
                    for (var n = this.random(); n <= 1e-7; ) n = this.random();
                    return -Math.log(n) * t;
                }
                for (;;) {
                    var n = this.random(), o = (Math.E + e) / Math.E, r = o * n, a = (s = r <= 1 ? Math.pow(r, 1 / e) : -Math.log((o - r) / e), 
                    this.random());
                    if (1 < r) {
                        if (a <= Math.pow(s, e - 1)) break;
                    } else if (a <= Math.exp(-s)) break;
                }
                return s * t;
            }
            for (var i = Math.sqrt(2 * e - 1), l = e - this.LOG4, u = e + i; ;) {
                var a = this.random();
                if (!(a < 1e-7 || .9999999 < n)) {
                    var s, f = 1 - this.random(), c = Math.log(a / (1 - a)) / i, f = a * a * f, c = l + u * c - (s = e * Math.exp(c));
                    if (0 <= c + this.SG_MAGICCONST - 4.5 * f || c >= Math.log(f)) return s * t;
                }
            }
        }, Random.prototype.normal = function(e, t) {
            if (2 != arguments.length) throw new SyntaxError("normal() must be called with mu and sigma parameters");
            var n, o, r = this.lastNormal;
            return this.lastNormal = NaN, r || (n = 2 * this.random() * Math.PI, 
            o = Math.sqrt(-2 * Math.log(1 - this.random())), r = Math.cos(n) * o, 
            this.lastNormal = Math.sin(n) * o), e + r * t;
        }, Random.prototype.pareto = function(e) {
            if (1 != arguments.length) throw new SyntaxError("pareto() must be called with alpha parameter");
            var t = this.random();
            return 1 / Math.pow(1 - t, 1 / e);
        }, Random.prototype.triangular = function(e, t, n) {
            if (3 != arguments.length) throw new SyntaxError("triangular() must be called with lower, upper and mode parameters");
            var o = (n - e) / (t - e), r = this.random();
            return r <= o ? e + Math.sqrt(r * (t - e) * (n - e)) : t - Math.sqrt((1 - r) * (t - e) * (t - n));
        }, Random.prototype.uniform = function(e, t) {
            if (2 != arguments.length) throw new SyntaxError("uniform() must be called with lower and upper parameters");
            return e + this.random() * (t - e);
        }, Random.prototype.weibull = function(e, t) {
            if (2 != arguments.length) throw new SyntaxError("weibull() must be called with alpha and beta parameters");
            var n = 1 - this.random();
            return e * Math.pow(-Math.log(n), 1 / t);
        }, "undefined" == typeof window && "undefined" != typeof module && module.exports && (module.exports = Random), 
        fluid || require("infusion")), flock = fluid.registerNamespace("flock");
        !function() {
            var e, o = fluid.registerNamespace("jQuery");
            flock.fluid = fluid, flock.init = function(e) {
                return flock.enviro(e ? {
                    components: {
                        audioSystem: {
                            options: {
                                model: e
                            }
                        }
                    }
                } : void 0);
            }, flock.ALL_CHANNELS = 32, flock.OUT_UGEN_ID = "flocking-out", flock.PI = Math.PI, 
            flock.TWOPI = 2 * Math.PI, flock.HALFPI = Math.PI / 2, flock.LOG01 = Math.log(.1), 
            flock.LOG001 = Math.log(.001), flock.ROOT2 = Math.sqrt(2), flock.rates = {
                AUDIO: "audio",
                CONTROL: "control",
                SCHEDULED: "scheduled",
                DEMAND: "demand",
                CONSTANT: "constant"
            }, fluid.registerNamespace("flock.debug"), flock.debug.failHard = !0, 
            flock.browser = function() {
                if ("undefined" == typeof navigator) return {};
                var e = navigator.userAgent.toLowerCase(), t = {}, e = /(chrome)[ \/]([\w.]+)/.exec(e) || /(webkit)[ \/]([\w.]+)/.exec(e) || /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(e) || /(msie) ([\w.]+)/.exec(e) || e.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(e) || [], e = {
                    browser: e[1] || "",
                    version: e[2] || "0"
                };
                return e.browser && (t[e.browser] = !0, t.version = e.version), 
                t.chrome ? t.webkit = !0 : t.webkit && (t.safari = !0), t;
            }, fluid.registerNamespace("flock.platform"), flock.platform.isBrowser = "undefined" != typeof window, 
            flock.platform.hasRequire = "undefined" != typeof require, flock.platform.os = flock.platform.isBrowser ? window.navigator.platform : require("os").platform(), 
            flock.platform.isLinux = -1 < flock.platform.os.indexOf("Linux"), flock.platform.isAndroid = flock.platform.isLinux && -1 < flock.platform.os.indexOf("arm"), 
            flock.platform.isIOS = "iPhone" === flock.platform.os || "iPad" === flock.platform.os || "iPod" === flock.platform.os, 
            flock.platform.isMobile = flock.platform.isAndroid || flock.platform.isIOS, 
            flock.platform.browser = flock.browser(), flock.platform.isWebAudio = "undefined" != typeof AudioContext || "undefined" != typeof webkitAudioContext, 
            flock.platform.audioEngine = flock.platform.isBrowser ? "webAudio" : "unknown", 
            flock.platform.browser && void 0 !== flock.platform.browser.version && (e = flock.platform.browser.version.indexOf("."), 
            flock.platform.browser.majorVersionNumber = Number(e < 0 ? flock.platform.browser.version : flock.platform.browser.version.substring(0, e))), 
            flock.shim = {
                URL: flock.platform.isBrowser ? window.URL || window.webkitURL || window.msURL : void 0
            }, flock.requireModule = function(e, t) {
                if (flock.platform.isBrowser) return window[t || e];
                if (flock.platform.hasRequire) return e = flock.requireModule.paths[e] || e, 
                e = require(e), t ? e[t] : e;
            }, flock.requireModule.paths = {
                webarraymath: "../third-party/webarraymath/js/webarraymath.js",
                Random: "../third-party/simjs/js/random-0.26.js"
            }, flock.noOp = function() {}, flock.isIterable = function(e) {
                var t = typeof e;
                return e && void 0 !== e.length && "string" != t && "function" != t;
            }, flock.hasValue = function(e, t) {
                var n, o = !1;
                for (n in e) if (e[n] === t) {
                    o = !0;
                    break;
                }
                return o;
            }, flock.hasTag = function(e, t) {
                return !(!e || !t) && (e.tags && -1 < e.tags.indexOf(t));
            }, flock.randomValue = function(e, t) {
                t -= e;
                return Math.random() * t + e;
            }, flock.randomAudioValue = function() {
                return 2 * Math.random() - 1;
            }, flock.fillBuffer = function(e, t) {
                for (var n = 0; n < e.length; n++) e[n] = t(n, e);
                return e;
            }, flock.fillBufferWithValue = function(e, t) {
                for (var n = 0; n < e.length; n++) e[n] = t;
                return e;
            }, flock.generateBuffer = function(e, t) {
                e = new Float32Array(e);
                return flock.fillBuffer(e, t);
            }, flock.generateBufferWithValue = function(e, t) {
                e = new Float32Array(e);
                return flock.fillBufferWithValue(e, t);
            }, flock.generate = function(e, t) {
                var n = "number" == typeof e;
                return ("function" == typeof t ? n ? flock.generateBuffer : flock.fillBuffer : n ? flock.generateBufferWithValue : flock.fillBufferWithValue)(e, t);
            }, flock.generate.silence = function(e) {
                return new Float32Array(e);
            }, flock.clearBuffer = function(e) {
                for (var t = 0; t < e.length; t++) e[t] = 0;
                return e;
            }, flock.reverse = function(e) {
                if (!e || !flock.isIterable(e) || e.length < 2) return e;
                if ("function" == typeof e.reverse) return e.reverse();
                for (var t, n = 0, o = e.length - 1; n < o; n++, o--) t = e[n], 
                e[n] = e[o], e[o] = t;
                return e;
            }, flock.randomIndex = function(e) {
                e = e.length - 1;
                return Math.round(Math.random() * e);
            }, flock.arrayChoose = function(e, t) {
                return t = t || flock.randomIndex, (e = fluid.makeArray(e))[t(e)];
            }, flock.choose = function(e, t) {
                return flock.isIterable(e) ? flock.arrayChoose(e, t) : e[flock.arrayChoose(e.keys, t)];
            }, flock.shuffle = function(e) {
                for (var t = e.length - 1; 0 < t; --t) {
                    var n = Math.floor(Math.random() * (t + 1)), o = e[t];
                    e[t] = e[n], e[n] = o;
                }
                return e;
            }, flock.normalize = function(e, t, n) {
                n = n || e;
                var o, r, a, i = 0;
                for (t = void 0 === t ? 1 : t, o = 0; o < e.length; o++) i < (r = Math.abs(e[o])) && (i = r);
                if (0 < i) for (o = 0; o < e.length; o++) a = e[o], n[o] = a / i * t;
                return n;
            }, flock.generateFourierTable = function(e, o, r, a, i) {
                return a *= flock.TWOPI, flock.generateBuffer(e, function(e) {
                    for (var t = 0, n = 0; n < r; n++) t += (i ? i[n] : 1) * Math.cos((n + 1) * (e * o) + a);
                    return t;
                });
            }, flock.generateNormalizedFourierTable = function(e, t, n, o, r) {
                var a = flock.generateBuffer(n, function(e) {
                    return r(e + 1);
                }), e = flock.generateFourierTable(e, t, n, o, a);
                return flock.normalize(e);
            }, flock.fillTable = function(e, t) {
                var n = "number" == typeof e ? e : e.length;
                return t(e, flock.TWOPI / n);
            }, flock.tableGenerators = {
                sin: function(e, t) {
                    return flock.generateBuffer(e, function(e) {
                        return Math.sin(e * t);
                    });
                },
                tri: function(e, t) {
                    return flock.generateNormalizedFourierTable(e, t, 1e3, 1, function(e) {
                        return e % 2 == 0 ? 0 : 1 / (e * e);
                    });
                },
                saw: function(e, t) {
                    return flock.generateNormalizedFourierTable(e, t, 10, -.25, function(e) {
                        return 1 / e;
                    });
                },
                square: function(e, t) {
                    return flock.generateNormalizedFourierTable(e, t, 10, -.25, function(e) {
                        return e % 2 == 0 ? 0 : 1 / e;
                    });
                },
                hann: function(t) {
                    return flock.generateBuffer(t, function(e) {
                        e = Math.sin(Math.PI * e / t);
                        return e * e;
                    });
                },
                sinWindow: function(t) {
                    return flock.generateBuffer(t, function(e) {
                        return Math.sin(Math.PI * e / t);
                    });
                }
            }, flock.range = function(e) {
                for (var t, n = {
                    max: Number.NEGATIVE_INFINITY,
                    min: 1 / 0
                }, o = 0; o < e.length; o++) (t = e[o]) > n.max && (n.max = t), 
                t < n.min && (n.min = t);
                return n;
            }, flock.scale = function(e) {
                if (e) {
                    for (var t = flock.range(e), n = (t.max - t.min) / 2, o = (t.max + t.min) / 2, r = 0; r < e.length; r++) e[r] = (e[r] - o) / n;
                    return e;
                }
            }, flock.copyBuffer = function(e, t, n) {
                void 0 === n && (n = e.length);
                for (var o = new Float32Array(n - t), r = t, a = 0; r < n; r++, 
                a++) o[a] = e[r];
                return o;
            }, flock.copyToBuffer = function(e, t) {
                for (var n = Math.min(e.length, t.length), o = 0; o < n; o++) t[o] = e[o];
            }, flock.parseMidiString = function(e) {
                if (!e || e.length < 2) return NaN;
                var t = (e = e.toLowerCase()).charAt(1), t = "#" === t || "b" === t ? 2 : 1, n = e.substring(0, t);
                return 12 * Number(e.substring(t)) + flock.midiFreq.noteNames[n];
            }, flock.midiFreq = function(e, t, n, o) {
                return t = void 0 === t ? 440 : t, n = void 0 === n ? 69 : n, o = o || 12, 
                "string" == typeof e && (e = flock.parseMidiString(e)), t * Math.pow(2, (e - n) / o);
            }, flock.midiFreq.noteNames = {
                "b#": 0,
                c: 0,
                "c#": 1,
                db: 1,
                d: 2,
                "d#": 3,
                eb: 3,
                e: 4,
                "e#": 5,
                f: 5,
                "f#": 6,
                gb: 6,
                g: 7,
                "g#": 8,
                ab: 8,
                a: 9,
                "a#": 10,
                bb: 10,
                b: 11,
                cb: 11
            }, flock.interpolate = {
                none: function(e, t) {
                    return t[0 | (e %= t.length)];
                },
                linear: function(e, t) {
                    var n = t.length, o = 0 | (e %= n), r = t[o];
                    return r + (e - o) * (t[(1 + o) % n] - r);
                },
                hermite: function(e, t) {
                    var n = t.length, o = Math.floor(e), r = o % n, e = e - o, o = t[0 < r ? r - 1 : n - 1], a = t[r], i = t[(1 + r) % n], o = .5 * (i - o), i = a - i, l = o + i, i = l + i + .5 * (t[(2 + r) % n] - a);
                    return ((i * e - (l + i)) * e + o) * e + a;
                }
            }, flock.interpolate.cubic = flock.interpolate.hermite, flock.log = {
                fail: function(e) {
                    fluid.log(fluid.logLevel.FAIL, e);
                },
                warn: function(e) {
                    fluid.log(fluid.logLevel.WARN, e);
                },
                debug: function(e) {
                    fluid.log(fluid.logLevel.INFO, e);
                }
            }, flock.fail = function(e) {
                if (flock.debug.failHard) throw e = e instanceof Error ? e : new Error(e);
                flock.log.fail(e);
            }, flock.pathParseError = function(e, t, n) {
                flock.fail("Error parsing path '" + t + "'. Segment '" + n + "' could not be resolved.");
            }, flock.get = function(e, t) {
                if (!e) return fluid.getGlobalValue(t);
                if (1 === arguments.length && "string" == typeof e) return fluid.getGlobalValue(e);
                if (t && "" !== t) {
                    for (var n = "" === t ? [] : String(t).split("."), o = e[n[0]], r = 1; r < n.length; r++) {
                        if (null == o) return void flock.pathParseError(e, t, n[r - 1]);
                        o = o[n[r]];
                    }
                    return o;
                }
            }, flock.set = function(e, t, n) {
                if (e && t && "" !== t) {
                    for (var o = String(t).split("."), r = o.length, a = o[0], i = 1; i < r; i++) {
                        if ("object" != typeof (e = e[a])) return void flock.fail("Error while setting a value at path '" + t + "'. A non-container object was found at segment '" + a + "'. Value: " + e);
                        void 0 === e[a = o[i]] && (e[a] = {});
                    }
                    return e[a] = n;
                }
            }, flock.invoke = function(e, t, n) {
                e = "function" == typeof e ? e : flock.get(e, t);
                if ("function" == typeof e) return e.apply(null, n);
                flock.fail("Path '" + t + "' does not resolve to a function.");
            }, flock.input = {}, flock.input.shouldExpand = function(e) {
                return flock.parse.specialInputs.indexOf(e) < 0;
            }, flock.input.pathExpander = function(e) {
                for (var t = fluid.model.parseEL(e), n = t.length - 1, o = [], r = 0; r < n; r++) {
                    var a = t[r], i = t[r + 1];
                    if (o.push(a), "model" === i || "options" === i) {
                        o = o.concat(t.slice(r + 1, n));
                        break;
                    }
                    isNaN(Number(i)) && o.push("inputs");
                }
                return o.push(t[n]), o.join(".");
            }, flock.input.expandPaths = function(e) {
                var t, n, o, r = {};
                for (t in e) n = flock.input.pathExpander(t), o = e[t], r[n] = o;
                return r;
            }, flock.input.expandPath = function(e) {
                return "string" == typeof e ? flock.input.pathExpander(e) : flock.input.expandPaths(e);
            }, flock.input.getValueForPath = function(e, t) {
                t = flock.input.expandPath(t);
                e = flock.get(e, t);
                return flock.hasTag(e, "flock.ugen.valueType") ? e.inputs.value : e;
            }, flock.input.getValuesForPathArray = function(e, t) {
                for (var n, o = {}, r = 0; r < t.length; r++) o[n = t[r]] = flock.input.get(e, n);
                return o;
            }, flock.input.getValuesForPathObject = function(e, t) {
                for (var n in t) t[n] = flock.input.get(e, n);
                return t;
            }, flock.input.get = function(e, t) {
                return "string" == typeof t ? flock.input.getValueForPath(e, t) : flock.isIterable(t) ? flock.input.getValuesForPathArray(e, t) : flock.input.getValuesForPathObject(e, t);
            }, flock.input.resolveValue = function(e, t, n, o, r, a, i) {
                if ("string" == typeof n) {
                    var l = fluid.extractEL(n, flock.input.valueExpressionSpec);
                    if (l) return void 0 === (e = flock.input.getValueForPath(e, l)) && flock.log.debug("The value expression '" + n + "' resolved to undefined. If this isn't expected, check to ensure that your path is valid."), 
                    e;
                }
                return flock.input.shouldExpand(r) && i ? i(n, t, o, a) : n;
            }, flock.input.valueExpressionSpec = {
                ELstyle: "${}"
            }, flock.input.setValueForPath = function(e, t, n, o, r) {
                t = flock.input.expandPath(t);
                var a = flock.get(e, t), i = t.lastIndexOf("."), l = t.slice(i + 1), i = -1 < i ? flock.get(e, t.slice(0, t.lastIndexOf(".inputs"))) : o, o = flock.input.resolveValue(e, t, n, i, l, a, r);
                return flock.set(e, t, o), i && i.onInputChanged && i.onInputChanged(l), 
                o;
            }, flock.input.setValuesForPaths = function(e, t, n, o) {
                var r, a, i = {};
                for (r in t) a = t[r], a = flock.input.set(e, r, a, n, o), i[r] = a;
                return i;
            }, flock.input.set = function(e, t, n, o, r) {
                return "string" == typeof t ? flock.input.setValueForPath(e, t, n, o, r) : flock.input.setValuesForPaths(e, t, o, r);
            }, fluid.defaults("flock.audioSystem", {
                gradeNames: [ "fluid.modelComponent" ],
                channelRange: {
                    min: 1,
                    max: 32
                },
                outputBusRange: {
                    min: 2,
                    max: 1024
                },
                inputBusRange: {
                    min: 1,
                    max: 32
                },
                model: {
                    rates: {
                        audio: 44100,
                        control: 689.0625,
                        scheduled: 0,
                        demand: 0,
                        constant: 0
                    },
                    blockSize: 64,
                    numBlocks: 16,
                    chans: 2,
                    numInputBuses: 2,
                    numBuses: 8,
                    bufferSize: "@expand:flock.audioSystem.defaultBufferSize()"
                },
                modelRelay: [ {
                    target: "rates.control",
                    singleTransform: {
                        type: "fluid.transforms.binaryOp",
                        left: "{that}.model.rates.audio",
                        operator: "/",
                        right: "{that}.model.blockSize"
                    }
                }, {
                    target: "numBlocks",
                    singleTransform: {
                        type: "fluid.transforms.binaryOp",
                        left: "{that}.model.bufferSize",
                        operator: "/",
                        right: "{that}.model.blockSize"
                    }
                }, {
                    target: "chans",
                    singleTransform: {
                        type: "fluid.transforms.limitRange",
                        input: "{that}.model.chans",
                        min: "{that}.options.channelRange.min",
                        max: "{that}.options.channelRange.max"
                    }
                }, {
                    target: "numInputBuses",
                    singleTransform: {
                        type: "fluid.transforms.limitRange",
                        input: "{that}.model.numInputBuses",
                        min: "{that}.options.inputBusRange.min",
                        max: "{that}.options.inputBusRange.max"
                    }
                }, {
                    target: "numBuses",
                    singleTransform: {
                        type: "fluid.transforms.free",
                        func: "flock.audioSystem.clampNumBuses",
                        args: [ "{that}.model.numBuses", "{that}.options.outputBusRange", "{that}.model.chans", "{that}.model.numInputBuses" ]
                    }
                } ]
            }), flock.audioSystem.clampNumBuses = function(e, t, n, o) {
                return e = Math.max(e, o + n), e = Math.max(e, Math.max(n, t.min)), 
                e = Math.min(e, t.max);
            }, flock.audioSystem.defaultBufferSize = function() {
                return flock.platform.isMobile ? 8192 : flock.platform.browser.mozilla ? 2048 : 1024;
            }, fluid.defaults("flock.busManager", {
                gradeNames: [ "fluid.modelComponent" ],
                model: {
                    nextAvailableBus: {
                        input: 0,
                        interconnect: 0
                    }
                },
                members: {
                    buses: {
                        expander: {
                            funcName: "flock.enviro.createAudioBuffers",
                            args: [ "{audioSystem}.model.numBuses", "{audioSystem}.model.blockSize" ]
                        }
                    }
                },
                invokers: {
                    acquireNextBus: {
                        funcName: "flock.busManager.acquireNextBus",
                        args: [ "{arguments}.0", "{that}.buses", "{that}.applier", "{that}.model", "{audioSystem}.model.chans", "{audioSystem}.model.numInputBuses" ]
                    },
                    reset: {
                        changePath: "nextAvailableBus",
                        value: {
                            input: 0,
                            interconnect: 0
                        }
                    }
                },
                listeners: {
                    "onDestroy.reset": "{that}.reset()"
                }
            }), flock.busManager.acquireNextBus = function(e, t, n, o, r, a) {
                o = o.nextAvailableBus[e];
                if (void 0 === o) flock.fail("An invalid bus type was specified when invoking flock.busManager.acquireNextBus(). Type was: " + e); else {
                    var i = o + r, r = r + a;
                    if ("interconnect" === e && (i += a, r = t.length), !(r <= i)) return n.change("nextAvailableBus." + e, ++o), 
                    i;
                    flock.fail("Unable to aquire a bus. There are insufficient buses available. Please use an existing bus or configure additional buses using the enviroment's numBuses and numInputBuses parameters.");
                }
            }, fluid.defaults("flock.outputManager", {
                gradeNames: [ "fluid.modelComponent" ],
                model: {
                    audioSettings: "{audioSystem}.model"
                },
                invokers: {
                    start: "{that}.events.onStart.fire()",
                    stop: "{that}.events.onStop.fire()",
                    reset: "{that}.events.onReset.fire"
                },
                events: {
                    onStart: "{enviro}.events.onStart",
                    onStop: "{enviro}.events.onStop",
                    onReset: "{enviro}.events.onReset"
                }
            }), fluid.defaults("flock.nodeListComponent", {
                gradeNames: "fluid.component",
                members: {
                    nodeList: "@expand:flock.nodeList()"
                },
                invokers: {
                    insert: "flock.nodeList.insert({that}.nodeList, {arguments}.0, {arguments}.1)",
                    head: "flock.nodeList.head({that}.nodeList, {arguments}.0)",
                    tail: "flock.nodeList.tail({that}.nodeList, {arguments}.0)",
                    before: "flock.nodeList.before({that}.nodeList, {arguments}.0, {arguments}.1)",
                    after: "flock.nodeList.after({that}.nodeList, {arguments}.0, {arguments}.1)",
                    remove: "flock.nodeList.remove({that}.nodeList, {arguments}.0)",
                    replace: "flock.nodeList.after({that}.nodeList, {arguments}.0, {arguments}.1)"
                }
            }), fluid.defaults("flock.enviro", {
                gradeNames: [ "fluid.modelComponent", "flock.nodeListComponent", "fluid.resolveRootSingle" ],
                singleRootType: "flock.enviro",
                isGlobalSingleton: !0,
                members: {
                    buffers: {},
                    bufferSources: {}
                },
                components: {
                    asyncScheduler: {
                        type: "flock.scheduler.async"
                    },
                    audioSystem: {
                        type: "flock.audioSystem"
                    },
                    busManager: {
                        type: "flock.busManager"
                    }
                },
                model: {
                    isPlaying: !1
                },
                invokers: {
                    generate: {
                        funcName: "flock.enviro.generate",
                        args: [ "{busManager}.buses", "{audioSystem}.model", "{that}.nodeList.nodes" ]
                    },
                    start: "flock.enviro.start({that}.model, {that}.events.onStart.fire)",
                    play: "{that}.start",
                    stop: "flock.enviro.stop({that}.model, {that}.events.onStop.fire)",
                    reset: "{that}.events.onReset.fire()",
                    registerBuffer: "flock.enviro.registerBuffer({arguments}.0, {that}.buffers)",
                    releaseBuffer: "flock.enviro.releaseBuffer({arguments}.0, {that}.buffers)",
                    saveBuffer: {
                        funcName: "flock.enviro.saveBuffer",
                        args: [ "{arguments}.0", "{that}.buffers", "{audioSystem}" ]
                    }
                },
                events: {
                    onStart: null,
                    onPlay: "{that}.events.onStart",
                    onStop: null,
                    onReset: null
                },
                listeners: {
                    "onCreate.registerSingleton": {
                        funcName: "flock.enviro.registerGlobalSingleton",
                        args: [ "{that}" ]
                    },
                    "onStart.updatePlayState": {
                        changePath: "isPlaying",
                        value: !0
                    },
                    "onStop.updatePlayState": {
                        changePath: "isPlaying",
                        value: !1
                    },
                    "onReset.stop": "{that}.stop()",
                    "onReset.clearScheduler": {
                        priority: "after:stop",
                        func: "{asyncScheduler}.clearAll"
                    },
                    "onReset.clearAllNodes": {
                        priority: "after:clearScheduler",
                        func: "flock.nodeList.clearAll",
                        args: [ "{that}.nodeList" ]
                    },
                    "onReset.resetBusManager": {
                        priority: "after:clearAllNodes",
                        func: "{busManager}.reset"
                    },
                    "onReset.clearBuffers": {
                        priority: "after:resetBusManager",
                        funcName: "fluid.clear",
                        args: [ "{that}.buffers" ]
                    }
                }
            }), flock.enviro.registerGlobalSingleton = function(e) {
                e.options.isGlobalSingleton && (flock.environment = flock.enviro.shared = e);
            }, flock.enviro.registerBuffer = function(e, t) {
                e.id && (t[e.id] = e);
            }, flock.enviro.releaseBuffer = function(e, t) {
                e && delete t["string" == typeof e ? e : e.id];
            }, flock.enviro.saveBuffer = function(e, t, n) {
                var o;
                return "string" == typeof (e = "string" == typeof e ? {
                    buffer: e
                } : e).buffer && (o = e.buffer, e.buffer = t[o], e.buffer.id = o), 
                e.type = e.type || "wav", e.path = e.path || e.buffer.id + "." + e.type, 
                e.format = e.format || "int16", n.bufferWriter.save(e, e.buffer);
            }, flock.enviro.generate = function(e, t, n) {
                flock.evaluate.clearBuses(e, t.numBuses, t.blockSize), flock.evaluate.synths(n);
            }, flock.enviro.start = function(e, t) {
                e.isPlaying || t();
            }, flock.enviro.stop = function(e, t) {
                e.isPlaying && t();
            }, flock.enviro.createAudioBuffers = function(e, t) {
                for (var n = [], o = 0; o < e; o++) n[o] = new Float32Array(t);
                return n;
            }, fluid.defaults("flock.autoEnviro", {
                gradeNames: [ "fluid.component" ],
                members: {
                    enviro: "@expand:flock.autoEnviro.initEnvironment()"
                }
            }), flock.autoEnviro.initEnvironment = function() {
                return flock.environment || flock.init();
            }, fluid.defaults("flock.silentEnviro", {
                gradeNames: "flock.enviro",
                listeners: {
                    "onCreate.insertGainNode": {
                        funcName: "flock.silentEnviro.insertOutputGainNode",
                        args: "{that}"
                    }
                }
            }), flock.silentEnviro.insertOutputGainNode = function(e) {
                e.audioSystem.nativeNodeManager && e.audioSystem.nativeNodeManager.createOutputNode({
                    node: "Gain",
                    params: {
                        gain: 0
                    }
                });
            }, fluid.defaults("flock.node", {
                gradeNames: [ "flock.autoEnviro", "fluid.modelComponent" ],
                addToEnvironment: "tail",
                model: {},
                members: {
                    generatorFunc: "@expand:fluid.getGlobalValue({that}.options.invokers.generate.funcName)"
                },
                components: {
                    enviro: "{flock.enviro}"
                },
                invokers: {
                    play: {
                        funcName: "flock.node.play",
                        args: [ "{that}", "{that}.enviro", "{that}.addToEnvironment" ]
                    },
                    pause: "{that}.removeFromEnvironment()",
                    addToEnvironment: {
                        funcName: "flock.node.addToEnvironment",
                        args: [ "{that}", "{arguments}.0", "{that}.enviro.nodeList" ]
                    },
                    removeFromEnvironment: {
                        funcName: "flock.node.removeFromEnvironment",
                        args: [ "{that}", "{that}.enviro.nodeList" ]
                    },
                    isPlaying: {
                        funcName: "flock.nodeList.isNodeActive",
                        args: [ "{that}.enviro.nodeList", "{that}" ]
                    },
                    generate: {
                        funcName: "fluid.identity"
                    }
                },
                listeners: {
                    "onCreate.addToEnvironment": {
                        func: "{that}.addToEnvironment",
                        args: [ "{that}.options.addToEnvironment" ]
                    },
                    "onDestroy.removeFromEnvironment": {
                        func: "{that}.removeFromEnvironment"
                    }
                }
            }), flock.node.addToEnvironment = function(e, t, n) {
                var o;
                null != (t = void 0 === t ? e.options.addToEnvironment : t) && !1 !== t && ("string" == (o = typeof t) && "head" === t || "tail" === t ? flock.nodeList[t](n, e) : "number" == o ? flock.nodeList.insert(n, e, t) : flock.nodeList.tail(n, e));
            }, flock.node.removeFromEnvironment = function(e, t) {
                flock.nodeList.remove(t, e);
            }, flock.node.play = function(e, t, n) {
                -1 === t.nodeList.nodes.indexOf(e) && n(e.options.addToEnvironment || "tail"), 
                t.model.isPlaying || t.play();
            }, fluid.defaults("flock.noteTarget", {
                gradeNames: "fluid.component",
                noteChanges: {
                    on: {
                        "env.gate": 1
                    },
                    off: {
                        "env.gate": 0
                    }
                },
                invokers: {
                    set: {
                        funcName: "fluid.notImplemented"
                    },
                    noteOn: {
                        func: "{that}.events.noteOn.fire"
                    },
                    noteOff: {
                        func: "{that}.events.noteOff.fire"
                    },
                    noteChange: {
                        funcName: "flock.noteTarget.change",
                        args: [ "{that}", "{arguments}.0", "{arguments}.1" ]
                    }
                },
                events: {
                    noteOn: null,
                    noteOff: null
                },
                listeners: {
                    "noteOn.handleChange": [ "{that}.noteChange(on, {arguments}.0)" ],
                    "noteOff.handleChange": [ "{that}.noteChange(off, {arguments}.0)" ]
                }
            }), flock.noteTarget.change = function(e, t, n) {
                t = e.options.noteChanges[t], t = o.extend({}, t, n);
                e.set(t);
            }, flock.bufferDesc = function() {
                throw new Error("flock.bufferDesc is not defined. Did you forget to include the buffers.js file?");
            };
        }();
        var fluid, flock, fluid, flock;
    }
    (flock = (fluid = fluid || require("infusion")).registerNamespace("flock")).nodeList = function() {
        return {
            nodes: [],
            namedNodes: {}
        };
    }, flock.nodeList.insert = function(e, t, n) {
        return e.nodes.splice(n = n < 0 ? 0 : n, 0, t), flock.nodeList.registerNode(e, t), 
        n;
    }, flock.nodeList.registerNode = function(e, t) {
        var n = t.name || t.id;
        n && (e.namedNodes[n] = t);
    }, flock.nodeList.head = function(e, t) {
        return flock.nodeList.insert(e, t, 0);
    }, flock.nodeList.before = function(e, t, n) {
        n = e.nodes.indexOf(n);
        return flock.nodeList.insert(e, t, n);
    }, flock.nodeList.after = function(e, t, n) {
        n = e.nodes.indexOf(n);
        return flock.nodeList.insert(e, t, n + 1);
    }, flock.nodeList.tail = function(e, t) {
        var n = e.nodes.length;
        return flock.nodeList.insert(e, t, n);
    }, flock.nodeList.unregisterNode = function(e, t) {
        t = t.name || t.id;
        t && delete e.namedNodes[t];
    }, flock.nodeList.isNodeActive = function(e, t) {
        return -1 < e.nodes.indexOf(t);
    }, flock.nodeList.remove = function(e, t) {
        var n;
        if (e) return n = e.nodes.indexOf(t), -1 < n && (e.nodes.splice(n, 1), flock.nodeList.unregisterNode(e, t)), 
        n;
    }, flock.nodeList.replace = function(e, t, n) {
        var o = e.nodes.indexOf(n);
        return o < 0 ? flock.nodeList.tail(e, t) : (e.nodes[o] = t, flock.nodeList.unregisterNode(e, n), 
        flock.nodeList.registerNode(e, t), o);
    }, flock.nodeList.clearAll = function(e) {
        for (var t in e.nodes.length = 0, e.namedNodes) delete e.namedNodes[t];
    }, flock.ugenNodeList = function() {
        return flock.nodeList();
    }, flock.ugenNodeList.insertTree = function(e, t, n) {
        var o, r, a = t.inputs;
        for (o in a) r = a[o], flock.isUGen(r) && (n = flock.ugenNodeList.insertTree(e, r, n), 
        n++);
        return flock.nodeList.insert(e, t, n);
    }, flock.ugenNodeList.removeTree = function(e, t) {
        var n, o, r = t.inputs;
        for (n in r) o = r[n], flock.isUGen(o) && flock.ugenNodeList.removeTree(e, o);
        return flock.nodeList.remove(e, t);
    }, flock.ugenNodeList.tailTree = function(e, t) {
        var n = e.nodes.length;
        return flock.ugenNodeList.insertTree(e, t, n);
    }, flock.ugenNodeList.replaceTree = function(e, t, n) {
        if (!n) return flock.ugenNodeList.tailTree(e, t);
        n = flock.ugenNodeList.removeTree(e, n);
        return flock.ugenNodeList.insertTree(e, t, n), n;
    }, flock.ugenNodeList.swapTree = function(e, t, n, o) {
        return o ? (flock.ugenNodeList.reattachInputs(e, t, n, o), flock.ugenNodeList.replaceInputs(e, t, n, o)) : t.inputs = n.inputs, 
        flock.nodeList.replace(e, t, n);
    }, flock.ugenNodeList.reattachInputs = function(e, t, n, o) {
        for (var r in n.inputs) o.indexOf(r) < 0 ? flock.ugenNodeList.removeTree(e, n.inputs[r]) : t.inputs[r] = n.inputs[r];
    }, flock.ugenNodeList.replaceInputs = function(e, t, n, o) {
        for (var r in t.inputs) o.indexOf(r) < 0 && flock.ugenNodeList.replaceTree(e, t.inputs[r], n.inputs[r]);
    }, flock.makeUGens = function(e, t, n, o, r) {
        e || fluid.log(fluid.logLevel.IMPORTANT, "Warning: An empy synthDef was found while instantiating a unit generator tree.Did you forget to include a 'synthDef' option for your Synth?");
        var a = t === flock.rates.SCHEDULED || t === flock.rates.DEMAND;
        return flock.parse.synthDef(e, o, {
            rate: t,
            overrideRate: a,
            visitors: [ flock.makeUGens.visitor(n) ],
            buffers: o.buffers,
            buses: o.busManager.buses,
            audioSettings: r || o.audioSystem.model
        });
    }, flock.makeUGens.visitor = function(t) {
        return function(e) {
            flock.nodeList.tail(t, e);
        };
    }, (flock = (fluid = fluid || require("infusion")).registerNamespace("flock")).evaluate = {
        synth: function(e) {
            flock.evaluate.ugens(e.nodeList.nodes);
        },
        synthValue: function(e) {
            return flock.evaluate.synth(e), e.out && (e.value = e.out.model.value), 
            e.value;
        },
        synthModel: function(e) {
            var t = flock.evaluate.synthValue(e);
            e.applier.change("value", t);
        },
        synths: function(e) {
            for (var t = 0; t < e.length; t++) {
                var n = e[t];
                n.generatorFunc(n);
            }
        },
        synthGroup: function(e) {
            flock.evaluate.synths(e.nodeList.nodes);
        },
        clearBuses: function(e, t, n) {
            for (var o = 0; o < t; o++) for (var r = e[o], a = 0; a < n; a++) r[a] = 0;
        },
        ugens: function(e) {
            for (var t, n = 0; n < e.length; n++) void 0 !== (t = e[n]).gen && t.gen(t.model.blockSize);
        }
    };
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    fluid.defaults("flock.band", {
        gradeNames: [ "fluid.component" ],
        synthGrade: "flock.noteTarget",
        invokers: {
            play: {
                func: "{that}.events.onPlay.fire"
            },
            pause: {
                func: "{that}.events.onPause.fire"
            },
            set: {
                func: "{that}.events.onSet.fire"
            },
            getSynths: {
                funcName: "fluid.queryIoCSelector",
                args: [ "{that}", "{that}.options.synthGrade" ]
            }
        },
        events: {
            onPlay: null,
            onPause: null,
            onSet: null
        },
        distributeOptions: [ {
            source: "{that}.options.synthListeners",
            removeSource: !0,
            target: "{that flock.synth}.options.listeners"
        } ],
        synthListeners: {
            "{band}.events.onPlay": {
                func: "{that}.play"
            },
            "{band}.events.onPause": {
                func: "{that}.pause"
            },
            "{band}.events.onSet": {
                func: "{that}.set"
            }
        }
    });
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    fluid.defaults("flock.synth.frameRate", {
        gradeNames: [ "flock.synth.value" ],
        rate: "scheduled",
        fps: 60,
        members: {
            audioSettings: {
                rates: {
                    scheduled: "{that}.options.fps"
                }
            }
        }
    });
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    fluid.defaults("flock.synth.group", {
        gradeNames: [ "flock.node", "flock.noteTarget" ],
        methodEventMap: {
            onSet: "set"
        },
        members: {
            nodeList: "@expand:flock.nodeList()"
        },
        invokers: {
            play: "{that}.events.onPlay.fire",
            pause: "{that}.events.onPause.fire",
            set: "{that}.events.onSet.fire",
            get: "flock.synth.group.get({arguments}, {that}.nodeList.nodes)",
            head: "flock.synth.group.head({arguments}.0, {that})",
            tail: "flock.synth.group.tail({arguments}.0, {that})",
            insert: "flock.synth.group.insert({arguments}.0, {arguments}.1, {that})",
            before: "flock.synth.group.before({arguments}.0, {arguments}.1, {that})",
            after: "flock.synth.group.after({arguments}.0, {arguments}.1, {that})",
            remove: "{that}.events.onRemove.fire",
            generate: {
                funcName: "flock.evaluate.synthGroup",
                args: [ "{that}" ]
            }
        },
        events: {
            onSet: null,
            onGen: null,
            onPlay: null,
            onPause: null,
            onInsert: null,
            onRemove: null
        },
        listeners: {
            "onInsert.bindMethods": {
                funcName: "flock.synth.group.bindMethods",
                args: [ "{arguments}.0", "{that}.options.methodEventMap", "{that}.events", "addListener" ]
            },
            "onInsert.removeNode": {
                priority: "after:bindMethods",
                funcName: "flock.synth.group.removeNodeFromEnvironment",
                args: [ "{arguments}.0" ]
            },
            "onRemove.bindMethods": {
                funcName: "flock.synth.group.bindMethods",
                args: [ "{arguments}.0", "{that}.options.methodEventMap", "{that}.events", "removeListener" ]
            },
            "onRemove.removeNode": {
                priority: "after:bindMethods",
                this: "{that}.nodeList",
                method: "remove",
                args: [ "{arguments}.0" ]
            }
        }
    }), flock.synth.group.head = function(e, t) {
        flock.nodeList.head(t.nodeList, e), t.events.onInsert.fire(e);
    }, flock.synth.group.tail = function(e, t) {
        flock.nodeList.tail(t.nodeList, e), t.events.onInsert.fire(e);
    }, flock.synth.group.insert = function(e, t, n) {
        flock.nodeList.insert(n.nodeList, e, t), n.events.onInsert.fire(e);
    }, flock.synth.group.before = function(e, t, n) {
        flock.nodeList.before(n.nodeList, e, t), n.events.onInsert.fire(e);
    }, flock.synth.group.after = function(e, t, n) {
        flock.nodeList.after(n.nodeList, e, t), n.events.onInsert.fire(e);
    }, flock.synth.group.removeNodeFromEnvironment = function(e) {
        e.removeFromEnvironment();
    }, flock.synth.group.get = function(e, t) {
        t = t[t.length - 1];
        return t.get.apply(t, e);
    }, flock.synth.group.input = function(e, t, n) {
        return (1 < e.length ? n : t).apply(null, e);
    }, flock.synth.group.bindMethods = function(e, t, n, o) {
        for (var r in t) {
            var a = e[t[r]];
            (0, n[r][o])(a);
        }
    };
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    fluid.defaults("flock.modelSynth", {
        gradeNames: "flock.synth",
        model: {
            inputs: {},
            value: void 0
        },
        modelListeners: {
            inputs: [ {
                funcName: "flock.modelSynth.updateUGens",
                args: [ "{that}.set", "{that}.options.ugens", "{change}" ]
            } ]
        },
        invokers: {
            generate: {
                funcName: "flock.evaluate.synthModel"
            }
        }
    }), flock.modelSynth.updateUGens = function(e, t, n) {
        var o = {};
        flock.modelSynth.flattenModel("", n.value, o), e(o);
    }, flock.modelSynth.shouldFlattenValue = function(e) {
        return fluid.isPrimitive(e) || flock.isIterable(e) || e.ugen;
    }, flock.modelSynth.flattenModel = function(e, t, n) {
        for (var o in t) {
            var r = t[o], o = fluid.pathUtil.composePath(e, o.toString());
            flock.modelSynth.shouldFlattenValue(r) ? n[o] = r : flock.modelSynth.flattenModel(o, r, n);
        }
        return n;
    };
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    !function() {
        var r = fluid.registerNamespace("jQuery");
        fluid.defaults("flock.synth.polyphonic", {
            gradeNames: [ "flock.synth.group" ],
            maxVoices: 16,
            amplitudeNormalizer: "static",
            amplitudeKey: "env.sustain",
            noteSpecs: "{that}.options.noteChanges",
            distributeOptions: {
                source: "{that}.options.voiceAllocatorOptions",
                target: "{that flock.synth.voiceAllocator}.options",
                removeSource: !0
            },
            voiceAllocatorOptions: {
                synthDef: "{polyphonic}.options.synthDef",
                maxVoices: "{polyphonic}.options.maxVoices",
                amplitudeNormalizer: "{polyphonic}.options.amplitudeNormalizer",
                amplitudeKey: "{polyphonic}.options.amplitudeKey",
                listeners: {
                    "onCreateVoice.addVoiceToTail": {
                        funcName: "flock.nodeList.tail",
                        args: [ "{polyphonic}.nodeList", "{arguments}.0" ]
                    }
                }
            },
            components: {
                voiceAllocator: {
                    type: "flock.synth.voiceAllocator.lazy"
                }
            },
            invokers: {
                noteChange: {
                    funcName: "flock.synth.polyphonic.noteChange",
                    args: [ "{that}", "{arguments}.0", "{arguments}.1", "{arguments}.2" ]
                },
                createVoice: {
                    func: "{voiceAllocator}.createVoice",
                    args: [ "{that}.options", "{that}.insert" ]
                }
            },
            listeners: {
                "noteOn.handleChange": [ {
                    funcName: "flock.synth.polyphonic.noteOn",
                    args: [ "{that}", "{arguments}.0", "{arguments}.1" ]
                } ],
                "noteOff.handleChange": [ {
                    funcName: "flock.synth.polyphonic.noteOff",
                    args: [ "{that}", "{arguments}.0", "{arguments}.1" ]
                } ]
            }
        }), flock.synth.polyphonic.noteChange = function(e, t, n, o) {
            e = e.options.noteChanges[t], t = r.extend({}, e, o);
            n.set(t);
        }, flock.synth.polyphonic.noteOn = function(e, t, n) {
            var o = e.voiceAllocator.getFreeVoice();
            return e.voiceAllocator.activeVoices[t] && e.noteOff(t), e.voiceAllocator.activeVoices[t] = o, 
            e.noteChange("on", o, n), o;
        }, flock.synth.polyphonic.noteOff = function(e, t, n) {
            var o = e.voiceAllocator.activeVoices[t];
            return o ? (e.noteChange("off", o, n), delete e.voiceAllocator.activeVoices[t], 
            e.voiceAllocator.freeVoices.push(o), o) : null;
        }, fluid.defaults("flock.synth.voiceAllocator", {
            gradeNames: [ "fluid.component" ],
            maxVoices: 16,
            amplitudeNormalizer: "static",
            amplitudeKey: "env.sustain",
            members: {
                activeVoices: {},
                freeVoices: []
            },
            invokers: {
                createVoice: {
                    funcName: "flock.synth.voiceAllocator.createVoice",
                    args: [ "{that}.options", "{that}.events.onCreateVoice.fire" ]
                }
            },
            events: {
                onCreateVoice: null
            }
        }), flock.synth.voiceAllocator.createVoice = function(e, t) {
            var n = flock.synth({
                synthDef: e.synthDef,
                addToEnvironment: !1
            }), o = e.amplitudeNormalizer, r = e.amplitudeKey;
            return o && ("function" == typeof o ? o(n, r) : "static" === o && (o = 1 / e.maxVoices, 
            n.set(r, o))), t(n), n;
        }, fluid.defaults("flock.synth.voiceAllocator.lazy", {
            gradeNames: [ "flock.synth.voiceAllocator" ],
            invokers: {
                getFreeVoice: {
                    funcName: "flock.synth.voiceAllocator.lazy.get",
                    args: [ "{that}.freeVoices", "{that}.activeVoices", "{that}.createVoice", "{that}.options.maxVoices" ]
                }
            }
        }), flock.synth.voiceAllocator.lazy.get = function(e, t, n, o) {
            return 1 < e.length ? e.pop() : Object.keys(t).length > o ? null : n();
        }, fluid.defaults("flock.synth.voiceAllocator.pool", {
            gradeNames: [ "flock.synth.voiceAllocator" ],
            invokers: {
                getFreeVoice: "flock.synth.voiceAllocator.pool.get({that}.freeVoices)"
            }
        }), flock.synth.voiceAllocator.pool.get = function(e) {
            if (0 < e.length) return e.pop();
        }, flock.synth.voiceAllocator.pool.allocateVoices = function(e, t, n) {
            for (var o = 0; o < n; o++) e[o] = t();
        };
    }();
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    fluid.defaults("flock.synth", {
        gradeNames: [ "flock.node", "flock.noteTarget" ],
        rate: flock.rates.AUDIO,
        addToEnvironment: !0,
        mergePolicy: {
            ugens: "nomerge"
        },
        ugens: {
            expander: {
                funcName: "flock.makeUGens",
                args: [ "{that}.options.synthDef", "{that}.rate", "{that}.nodeList", "{that}.enviro", "{that}.audioSettings" ]
            }
        },
        members: {
            rate: "{that}.options.rate",
            audioSettings: "{that}.enviro.audioSystem.model",
            nodeList: "@expand:flock.nodeList()",
            out: "{that}.options.ugens"
        },
        model: {
            blockSize: "@expand:flock.synth.calcBlockSize({that}.rate, {that}.enviro.audioSystem.model)"
        },
        invokers: {
            set: {
                funcName: "flock.synth.set",
                args: [ "{that}", "{that}.nodeList.namedNodes", "{arguments}.0", "{arguments}.1", "{arguments}.2" ]
            },
            get: {
                funcName: "flock.input.get",
                args: [ "{that}.nodeList.namedNodes", "{arguments}.0" ]
            },
            generate: {
                funcName: "flock.evaluate.synth",
                args: [ "{that}" ]
            }
        }
    }), flock.synth.createUGenTree = function(e, t, n) {
        return new flock.UGenTree(e, t, n);
    }, flock.synth.calcBlockSize = function(e, t) {
        return e === flock.rates.AUDIO ? t.blockSize : 1;
    }, flock.synth.set = function(r, e, t, n, a) {
        return flock.input.set(e, t, n, void 0, function(e, t, n, o) {
            return flock.synth.ugenValueParser(r, e, o, a);
        });
    }, flock.synth.input = function(e, t, n) {
        var o = e[0];
        return o ? "string" == typeof o ? e.length < 2 ? t(o) : n.apply(null, e) : flock.isIterable(o) ? t(o) : n.apply(null, e) : void 0;
    }, flock.synth.ugenValueParser = function(e, t, n, o) {
        if (null == t) return n;
        for (var r, a, t = flock.parse.ugenDef(t, e.enviro, {
            audioSettings: e.audioSettings,
            buses: e.enviro.busManager.buses,
            buffers: e.enviro.buffers
        }), i = flock.isIterable(t) ? t : void 0 !== t ? [ t ] : [], l = flock.isIterable(n) ? n : void 0 !== n ? [ n ] : [], u = Math.min(i.length, l.length), s = o ? "swapTree" : "replaceTree", f = 0; f < u; f++) r = flock.ugenNodeList[s](e.nodeList, i[f], l[f]);
        for (a = f; a < i.length; a++) flock.ugenNodeList.insertTree(e.nodeList, i[a], ++r);
        for (a = f; a < l.length; a++) flock.ugenNodeList.removeTree(e.nodeList, l[a]);
        return t;
    };
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    fluid.defaults("flock.synth.value", {
        gradeNames: [ "flock.synth" ],
        rate: "demand",
        addToEnvironment: !1,
        invokers: {
            generate: {
                funcName: "flock.evaluate.synthValue"
            }
        }
    });
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    !function() {
        function e() {
            var i = [], l = {
                state: "pending",
                value: void 0,
                resolve: function(e) {
                    t("resolve", e), l.state = "fulfilled";
                },
                reject: function(e) {
                    t("reject", e), l.state = "rejected";
                },
                then: function(e, t) {
                    return i ? i.push({
                        resolve: e,
                        reject: t
                    }) : ("fulfilled" === l.state ? e : t)(l.value), this;
                },
                safe: {
                    then: function(e, t) {
                        return l.then(e, t), this;
                    }
                }
            };
            function t(e, n) {
                l.value = n, l.then = "reject" === e ? function(e, t) {
                    return t(n), this;
                } : function(e) {
                    return e(n), this;
                }, l.resolve = l.reject = function() {
                    throw new Error("Promise already completed");
                };
                var t, o, r = e, a = n;
                for (t = 0; t < i.length; t++) (o = i[t])[r] && o[r](a);
                i = null;
            }
            return l;
        }
        fluid.defaults("flock.promise", {
            gradeNames: [ "fluid.component" ],
            members: {
                promise: {
                    expander: {
                        funcName: "flock.promise.make"
                    }
                }
            }
        }), flock.promise.make = function() {
            return new e();
        }, flock.bufferDesc = function(e, t, n) {
            return (flock.platform.isWebAudio && e instanceof AudioBuffer ? flock.bufferDesc.fromAudioBuffer : flock.isIterable(e) ? flock.bufferDesc.fromChannelArray : flock.bufferDesc.expand)(e, t, n);
        }, flock.bufferDesc.inferFormat = function(e, t, n) {
            var o = e.format, r = e.data;
            return o.sampleRate = t || o.sampleRate || 44100, o.numChannels = n || o.numChannels || e.data.channels.length, 
            o.numSampleFrames = o.numSampleFrames || 0 < r.channels.length ? r.channels[0].length : 0, 
            o.duration = o.numSampleFrames / o.sampleRate, e;
        }, flock.bufferDesc.fromChannelArray = function(e, t, n) {
            e = {
                container: {},
                format: {
                    numChannels: n,
                    sampleRate: t,
                    numSampleFrames: (e = e instanceof Float32Array ? [ e ] : e)[0].length
                },
                data: {
                    channels: e
                }
            };
            return flock.bufferDesc.inferFormat(e, t, n);
        }, flock.bufferDesc.expand = function(e, t, n) {
            if ((e = e || {
                data: {
                    channels: []
                }
            }).container = e.container || {}, e.format = e.format || {}, e.format.numChannels = n || e.format.numChannels || e.data.channels.length, 
            e.data && e.data.channels && (1 === e.format.numChannels && 1 !== e.data.channels.length && (e.data.channels = [ e.data.channels ]), 
            e.format.numChannels !== e.data.channels.length)) throw new Error("The specified number of channels does not match the actual channel data. numChannels was: " + e.format.numChannels + " but the sample data contains " + e.data.channels.length + " channels.");
            return flock.bufferDesc.inferFormat(e, t, n);
        }, flock.bufferDesc.fromAudioBuffer = function(e) {
            for (var t = {
                container: {},
                format: {
                    sampleRate: e.sampleRate,
                    numChannels: e.numberOfChannels,
                    numSampleFrames: e.length,
                    duration: e.duration
                },
                data: {
                    channels: []
                }
            }, n = 0; n < e.numberOfChannels; n++) t.data.channels.push(e.getChannelData(n));
            return t;
        }, flock.bufferDesc.toAudioBuffer = function(e, t) {
            for (var n = e.createBuffer(t.format.numChannels, t.format.numSampleFrames, t.format.sampleRate), o = 0; o < t.format.numChannels; o++) n.copyToChannel(t.data.channels[o], o);
            return n;
        }, fluid.defaults("flock.bufferSource", {
            gradeNames: [ "fluid.modelComponent" ],
            sampleRate: "{enviro}.audioSystem.model.sampleRate",
            model: {
                state: "start",
                src: null
            },
            components: {
                bufferPromise: {
                    createOnEvent: "onRefreshPromise",
                    type: "flock.promise",
                    options: {
                        listeners: {
                            "onCreate.bindPromiseEvents": {
                                this: "{that}.promise",
                                method: "then",
                                args: [ "{bufferSource}.events.afterFetch.fire", "{bufferSource}.events.onError.fire" ]
                            }
                        }
                    }
                }
            },
            invokers: {
                get: {
                    funcName: "flock.bufferSource.get",
                    args: [ "{that}", "{arguments}.0" ]
                },
                set: {
                    funcName: "flock.bufferSource.set",
                    args: [ "{that}", "{arguments}.0" ]
                },
                error: {
                    funcName: "flock.bufferSource.error",
                    args: [ "{that}", "{arguments}.0" ]
                }
            },
            listeners: {
                "onCreate.fireRefresh": {
                    funcName: "{that}.events.onRefreshPromise.fire"
                },
                "onRefreshPromise.updateState": {
                    changePath: "state",
                    value: "start"
                },
                "onFetch.updateState": {
                    changePath: "state",
                    value: "in-progress"
                },
                "afterFetch.updateState": {
                    changePath: "state",
                    value: "fetched"
                },
                "afterFetch.fireBufferUpdated": {
                    priority: "after:updateState",
                    funcName: "{that}.events.onBufferUpdated.fire",
                    args: [ "{arguments}.0" ]
                },
                "onBufferUpdated.registerBuffer": {
                    func: "{enviro}.registerBuffer",
                    args: [ "{arguments}.0" ]
                },
                "onError.updateState": {
                    changePath: "state",
                    value: "error"
                }
            },
            events: {
                onRefreshPromise: null,
                onError: null,
                onFetch: null,
                afterFetch: null,
                onBufferUpdated: null
            }
        }), flock.bufferSource.get = function(t, n) {
            return "in-progress" === t.model.state || n.src === t.model.src && !n.replace || n.src && ("fetched" !== t.model.state && "errored" !== t.model.state || t.model.src === n.src && !n.replace || t.events.onRefreshPromise.fire(), 
            "start" === t.model.state && (t.model.src = n.src, t.events.onFetch.fire(n), 
            flock.audio.decode({
                src: n.src,
                sampleRate: t.options.sampleRate,
                success: function(e) {
                    n.id && (e.id = n.id), t.set(e);
                },
                error: t.error
            }))), t.bufferPromise.promise;
        }, flock.bufferSource.set = function(e, t) {
            var n = e.model.state;
            return "start" !== n && "in-progress" !== n || e.bufferPromise.promise.resolve(t), 
            e.bufferPromise.promise;
        }, flock.bufferSource.error = function(e, t) {
            return e.bufferPromise.promise.reject(t), e.bufferPromise.promise;
        }, fluid.defaults("flock.bufferLoader", {
            gradeNames: [ "fluid.component" ],
            bufferDefs: [],
            members: {
                buffers: [],
                bufferDefs: "@expand:flock.bufferLoader.expandBufferDefs({that}.options.bufferDefs)"
            },
            components: {
                enviro: "{flock.enviro}"
            },
            events: {
                afterBuffersLoaded: null,
                onError: null
            },
            listeners: {
                "onCreate.loadBuffers": {
                    funcName: "flock.bufferLoader.loadBuffers",
                    args: [ "{that}" ]
                },
                "onError.logError": {
                    funcName: "flock.log.fail"
                }
            }
        }), flock.bufferLoader.idFromURL = function(e) {
            var t = e.lastIndexOf("/"), t = -1 < t ? t + 1 : 0, n = e.lastIndexOf("."), n = -1 < n ? n : e.length;
            return e.substring(t, n);
        }, flock.bufferLoader.idsFromURLs = function(e) {
            return fluid.transform(e, flock.bufferLoader.idFromURL);
        }, flock.bufferLoader.expandFileSequence = function(e) {
            e = e || [];
            for (var t, n, o = [], r = 0; r < e.length; r++) t = e[r], n = flock.bufferLoader.idFromURL(t), 
            o.push({
                id: n,
                url: t
            });
            return o;
        }, flock.bufferLoader.expandBufferDef = function(e) {
            return void 0 === (e = "string" == typeof e ? {
                url: e
            } : e).id && void 0 !== e.url && (e.id = flock.bufferLoader.idFromURL(e.url)), 
            e;
        }, flock.bufferLoader.expandBufferDefs = function(e) {
            return e ? (e = fluid.makeArray(e), fluid.transform(e, flock.bufferLoader.expandBufferDef)) : [];
        }, flock.bufferLoader.loadBuffer = function(e, t, n) {
            try {
                flock.parse.bufferForDef(e, t, n.enviro);
            } catch (e) {
                n.events.onError.fire(e.message);
            }
        }, flock.bufferLoader.loadBuffers = function(t) {
            var n = 1, o = {
                setBuffer: function(e) {
                    t.buffers.push(e), t.buffers.length === t.options.bufferDefs.length ? t.events.afterBuffersLoaded.fire(t.buffers) : n < t.bufferDefs.length && (e = t.bufferDefs[n], 
                    flock.bufferLoader.loadBuffer(e, o, t), n++);
                }
            };
            flock.bufferLoader.loadBuffer(t.bufferDefs[0], o, t);
        };
    }();
    var fluid, flock = (fluid = fluid || require("infusion")).registerNamespace("flock");
    !function() {
        var d = fluid.registerNamespace("jQuery");
        fluid.registerNamespace("flock.parse"), flock.parse.synthDef = function(e, t, n) {
            return flock.parse.synthDef.hasOutUGen(e = e || []) || (e = flock.parse.synthDef.makeOutUGenDef(e, n)), 
            flock.parse.ugenForDef(e, t, n);
        }, flock.parse.synthDef.hasOutUGen = function(e) {
            return !flock.isIterable(e) && (e.id === flock.OUT_UGEN_ID || "flock.ugen.out" === e.ugen || "flock.ugen.valueOut" === e.ugen);
        }, flock.parse.synthDef.makeOutUGenDef = function(e, t) {
            return e = {
                id: flock.OUT_UGEN_ID,
                ugen: "flock.ugen.valueOut",
                inputs: {
                    sources: e
                }
            }, t.rate === flock.rates.AUDIO && (e.ugen = "flock.ugen.out", e.inputs.bus = 0, 
            e.inputs.expand = t.audioSettings.chans), e;
        }, flock.parse.makeUGen = function(e, t, n, o) {
            var r = o.audioSettings.rates, a = o.audioSettings.blockSize, i = (e.rate || (e.rate = flock.rates.AUDIO), 
            flock.hasValue(flock.rates, e.rate) || (flock.fail("An invalid rate was specified for a unit generator. ugenDef was: " + fluid.prettyPrintJSON(e)), 
            flock.debug.failHard || (f = e.rate, e.rate = flock.rates.AUDIO, flock.log.warn("Overriding invalid unit generator rate. Rate is now '" + e.rate + "'; was: " + fluid.prettyPrintJSON(f)))), 
            f = e.options && void 0 !== e.options.sampleRate ? e.options.sampleRate : r[e.rate], 
            e.options = d.extend(!0, {}, e.options, {
                sampleRate: f,
                rate: e.rate,
                audioSettings: {
                    rates: r,
                    blockSize: a
                }
            }), e.rate === flock.rates.AUDIO ? a : 1);
            if (flock.hasTag(e.options, "flock.ugen.multiChannelOutput")) for (var l = e.options.numOutputs || 1, u = [], s = 0; s < l; s++) u.push(new Float32Array(i)); else u = new Float32Array(i);
            var f = fluid.copy(e.options);
            return f.buffers = o.buffers, f.buses = o.buses, f.enviro = n, flock.invoke(void 0, e.ugen, [ t, u, f ]);
        }, flock.parse.reservedWords = [ "id", "ugen", "rate", "inputs", "options" ], 
        flock.parse.specialInputs = [ "value", "buffer", "list", "table", "envelope", "durations", "values" ], 
        flock.parse.expandInputs = function(e) {
            if (e.inputs) return e;
            var t, n = {};
            for (t in e) -1 === flock.parse.reservedWords.indexOf(t) && (n[t] = e[t], 
            delete e[t]);
            return e.inputs = n, e;
        }, flock.parse.ugenDefForConstantValue = function(e) {
            return {
                ugen: "flock.ugen.value",
                rate: flock.rates.CONSTANT,
                inputs: {
                    value: e
                }
            };
        }, flock.parse.expandValueDef = function(e) {
            var t = typeof e;
            if ("number" == t) return flock.parse.ugenDefForConstantValue(e);
            if ("object" == t) return e;
            throw new Error("Invalid value type found in ugen definition. UGenDef was: " + fluid.prettyPrintJSON(e));
        }, flock.parse.rateMap = {
            ar: flock.rates.AUDIO,
            kr: flock.rates.CONTROL,
            sr: flock.rates.SCHEDULED,
            dr: flock.rates.DEMAND,
            cr: flock.rates.CONSTANT
        }, flock.parse.expandRate = function(e, t) {
            return e.rate = flock.parse.rateMap[e.rate] || e.rate, t.overrideRate && e.rate !== flock.rates.CONSTANT && (e.rate = t.rate), 
            e;
        }, flock.parse.ugenDef = function(e, t, n) {
            return (flock.isIterable(e) ? flock.parse.ugensForDefs : flock.parse.ugenForDef)(e, t, n);
        }, flock.parse.ugenDef.mergeOptions = function(e) {
            var t = flock.ugenDefaults(e.ugen) || {};
            return (t = fluid.copy(t)).options = t.ugenOptions, delete t.ugenOptions, 
            d.extend(!0, {}, t, e);
        }, flock.parse.ugensForDefs = function(e, t, n) {
            for (var o = [], r = 0; r < e.length; r++) o[r] = flock.parse.ugenForDef(e[r], t, n);
            return o;
        }, flock.parse.ugenForDef = function(e, t, n) {
            t = t || flock.environment;
            var o = n = d.extend(!0, {
                audioSettings: t.audioSystem.model,
                buses: t.busManager.buses,
                buffers: t.buffers
            }, n), r = o.visitors, a = o.audioSettings.rates;
            if (e = flock.parse.expandValueDef(e), flock.isIterable(e)) return flock.parse.ugensForDefs(e, t, n);
            e = flock.parse.expandInputs(e), flock.parse.expandRate(e, n);
            var i, l = (e = flock.parse.ugenDef.mergeOptions(e, n)).inputs, u = {};
            for (i in l) {
                var s = l[i];
                null !== s && (u[i] = flock.input.shouldExpand(i, e) ? flock.parse.ugenForDef(s, t, n) : s);
            }
            if (!e.ugen) throw new Error("Unit generator definition lacks a 'ugen' property; can't initialize the synth graph. Value: " + fluid.prettyPrintJSON(e));
            var f = flock.parse.makeUGen(e, u, t, n);
            if (e.id && (f.id = e.id), f.options.ugenDef = e, r) for (var c = 0; c < r.length; c++) r[c](f, e, a);
            return f;
        }, flock.parse.expandBufferDef = function(e) {
            return "string" == typeof e ? {
                id: e
            } : flock.isIterable(e) || e.data || e.format ? flock.bufferDesc(e) : e;
        }, flock.parse.bufferForDef = function(e, t, n) {
            (e = flock.parse.expandBufferDef(e)).data && e.data.channels ? (e = flock.bufferDesc(e), 
            flock.parse.bufferForDef.resolveBuffer(e, t, n)) : flock.parse.bufferForDef.resolveDef(e, t, n);
        }, flock.parse.bufferForDef.createBufferSource = function(e) {
            return flock.bufferSource({
                sampleRate: e.audioSystem.model.sampleRate
            });
        }, flock.parse.bufferForDef.findSource = function(e, t) {
            var n;
            return t && e.id ? (n = t.bufferSources[e.id]) || (n = flock.parse.bufferForDef.createBufferSource(t), 
            t.bufferSources[e.id] = n) : n = flock.parse.bufferForDef.createBufferSource(t), 
            n;
        }, flock.parse.bufferForDef.bindToPromise = function(e, t, n) {
            function o(e) {
                t.events.onBufferUpdated.addListener(o), n && n.setBuffer(e);
            }
            e.then(o, function(e) {
                throw !e && t.model.src && t.model.src.indexOf(".aif") && (e = "if this is an AIFF file, you might need to include flocking-audiofile-compatibility.js in some browsers."), 
                new Error("Error while resolving buffer " + t.model.src + ": " + e);
            });
        }, flock.parse.bufferForDef.resolveDef = function(e, t, n) {
            n = flock.parse.bufferForDef.findSource(e, n);
            e.src = e.url || e.src, e.selector && "undefined" != typeof document && (e.src = document.querySelector(e.selector).files[0]), 
            e = n.get(e), flock.parse.bufferForDef.bindToPromise(e, n, t);
        }, flock.parse.bufferForDef.resolveBuffer = function(e, t, n) {
            n = flock.parse.bufferForDef.findSource(e, n), e = n.set(e);
            flock.parse.bufferForDef.bindToPromise(e, n, t);
        };
    }();
}

(flock = (fluid = fluid || require("infusion")).registerNamespace("flock")).applyDeferred = function(e, t, n) {
    e && (n = void 0 === n ? 0 : n, setTimeout(function() {
        e.apply(null, t);
    }, n));
}, fluid.registerNamespace("flock.net"), flock.net.readBufferFromUrl = function(e) {
    var t = e.src, n = new XMLHttpRequest();
    n.onreadystatechange = function() {
        if (4 === n.readyState) if (flock.net.isXHRSuccessful(n)) e.success(n.response, flock.file.parseFileExtension(t)); else {
            if (!e.error) throw new Error(n.statusText);
            e.error(n.statusText);
        }
    }, n.open(e.method || "GET", t, !0), n.responseType = e.responseType || "arraybuffer", 
    n.send(e.data);
}, flock.net.isXHRSuccessful = function(e) {
    return 200 === e.status || 0 === e.responseURL.indexOf("file://") && 0 === e.status && e.response;
}, fluid.registerNamespace("flock.file"), flock.file.mimeTypes = {
    "audio/wav": "wav",
    "audio/x-wav": "wav",
    "audio/wave": "wav",
    "audio/x-aiff": "aiff",
    "audio/aiff": "aiff",
    "sound/aiff": "aiff"
}, flock.file.typeAliases = {
    aif: "aiff",
    wave: "wav"
}, flock.file.parseFileExtension = function(e) {
    var t = e.lastIndexOf(".");
    if (!(t < 0)) return e = (e = e.substring(t + 1)).toLowerCase(), flock.file.typeAliases[e] || e;
}, flock.file.parseMIMEType = function(e) {
    return flock.file.mimeTypes[e];
}, flock.file.stringToBuffer = function(e) {
    for (var t = e.length, n = new ArrayBuffer(t), o = new Uint8Array(n), r = 0; r < t; r++) o[r] = e.charCodeAt(r);
    return o.buffer;
}, flock.file.readBufferFromDataUrl = function(t) {
    var e = t.src, n = e.indexOf(","), o = e.substring(0, n), r = e.substring(n + 1), o = o.indexOf(";base64"), a = -1 < o, i = e.indexOf("data:") + 5, l = e.substring(i, a ? o : n);
    a && (r = atob(r)), flock.applyDeferred(function() {
        var e = flock.file.stringToBuffer(r);
        t.success(e, flock.file.parseMIMEType(l));
    });
}, flock.file.readBufferFromFile = function(t) {
    var e = new FileReader();
    return e.onload = function(e) {
        t.success(e.target.result, flock.file.parseFileExtension(t.src.name));
    }, e.readAsArrayBuffer(t.src), e;
}, fluid.registerNamespace("flock.audio"), flock.audio.loadBuffer = function(e) {
    var t = e.src || e.url;
    t && (t instanceof ArrayBuffer && flock.applyDeferred(e.success, [ t, e.type ]), 
    flock.audio.loadBuffer.readerForSource(t)(e));
}, flock.audio.loadBuffer.readerForSource = function(e) {
    return "undefined" != typeof File && e instanceof File ? flock.file.readBufferFromFile : 0 === e.indexOf("data:") ? flock.file.readBufferFromDataUrl : flock.net.readBufferFromUrl;
}, flock.audio.decode = function(o) {
    var r = o.success;
    o.success = function(e, t) {
        var n = flock.audio.decoderStrategies, n = n[t] || n.default;
        (n = o.decoder ? "string" == typeof o.decoder ? fluid.getGlobalValue(o.decoder) : o.decoder : n)({
            rawData: e,
            type: t,
            success: r,
            error: o.error,
            sampleRate: o.sampleRate
        });
    }, flock.audio.loadBuffer(o);
}, flock.audio.decode.webAudio = function(t) {
    flock.webAudio.audioSystem.audioContextSingleton.decodeAudioData(t.rawData, function(e) {
        e = flock.bufferDesc.fromAudioBuffer(e);
        t.success(e);
    }, t.error);
}, flock.audio.decoderStrategies = {
    default: flock.audio.decode.webAudio
}, flock.audio.registerDecoderStrategy = function(e, t) {
    if (e) if ("object" == typeof e) for (var n in e) flock.audio.decoderStrategies[n] = e[n]; else "string" == typeof t && (t = fluid.getGlobalValue(t)), 
    flock.audio.decoderStrategies[e] = t;
};

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

!function() {
    var e, i = "undefined" != typeof window ? window : "undefined" != typeof self ? self : global;
    for (e in fluid.registerNamespace("flock.audio.convert"), flock.audio.convert.maxFloatValue = function(e) {
        return 1 - 1 / e.scale;
    }, flock.audio.convert.pcm = {
        int8: {
            scale: 128,
            setter: "setInt8",
            width: 1
        },
        int16: {
            scale: 32768,
            setter: "setInt16",
            width: 2
        },
        int32: {
            scale: 2147483648,
            setter: "setInt32",
            width: 4
        },
        float32: {
            scale: 1,
            setter: "setFloat32",
            width: 4
        }
    }, flock.audio.convert.pcm) {
        var t = flock.audio.convert.pcm[e];
        t.maxFloatValue = flock.audio.convert.maxFloatValue(t);
    }
    flock.audio.convert.specForPCMType = function(e) {
        var t = "string" == typeof e ? flock.audio.convert.pcm[e] : e;
        return t || flock.fail("Flocking does not support " + e + " format PCM wave files."), 
        t;
    }, flock.audio.convert.floatToInt = function(e, t) {
        e = Math.min(t.maxFloatValue, e), e = Math.max(-1, e);
        return e *= t.scale, e = Math.round(e);
    }, flock.audio.convert.floatsToInts = function(e, t) {
        if (e) {
            for (var n = "Int" + 8 * t.width + "Array", o = new i[n](e.length), r = 0; r < e.length; r++) {
                var a = e[r], a = flock.audio.convert.floatToInt(a, t);
                o[r] = a;
            }
            return o;
        }
    }, flock.audio.convert.intToFloat = function(e, t) {
        return e / t.scale;
    }, flock.audio.convert.intsToFloats = function(e, t) {
        if (e) {
            for (var n = new Float32Array(e.length), o = 0; o < e.length; o++) {
                var r = e[o], r = flock.audio.convert.intToFloat(r, t);
                n[o] = r;
            }
            return n;
        }
    };
}();

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

fluid.registerNamespace("flock.audio.encode"), flock.audio.interleave = function(e) {
    for (var t, n = e.format.numSampleFrames, o = e.data.channels, r = e.format.numChannels, a = new Float32Array(n * r), i = 0, l = 0; l < n; l++) for (t = 0; t < r; t++) a[i] = o[t][l], 
    i++;
    return a;
}, flock.audio.encode = function(e, t, n) {
    return "wav" !== (t = t || "wav").toLowerCase() && flock.fail("Flocking currently only supports encoding WAVE files."), 
    flock.audio.encode.wav(e, n);
}, flock.audio.encode.writeFloat32Array = function(e, t, n) {
    for (var o = 0; o < n.length; o++) t.setFloat32(e, n[o], !0), e += 4;
    return t;
}, flock.audio.encode.setString = function(e, t, n) {
    for (var o = 0; o < n.length; o++) e.setUint8(t + o, n.charCodeAt(o));
}, flock.audio.encode.setBytes = function(e, t, n) {
    for (var o = 0; o < n.length; o++) e.setUint8(t + o, n[o]);
}, flock.audio.encode.writeAsPCM = function(e, t, n, o) {
    if ("setFloat32" === e.setter && o instanceof Float32Array) return flock.audio.encode.writeFloat32Array(t, n, o);
    for (var r = 0; r < o.length; r++) {
        var a = flock.audio.convert.floatToInt(o[r], e);
        n[e.setter](t, a, !0), t += e.width;
    }
    return n;
}, flock.audio.encode.wav = function(e, t) {
    t = t || flock.audio.convert.pcm.int16;
    var t = flock.audio.convert.specForPCMType(t), n = flock.audio.interleave(e), o = e.format.numChannels, r = e.format.sampleRate, a = "setFloat32" !== t.setter, i = 16, l = 1, u = n.length * t.width, s = t.width * o, f = 8 * t.width;
    (2 < o || !a) && (i += 12, l = 2 < o ? (i += 24, 65534) : (i += 2, 3));
    var c = 12 + i + (8 + u), d = new ArrayBuffer(8 + c), d = new DataView(d), c = (flock.audio.encode.setString(d, 0, "RIFF"), 
    d.setUint32(4, c, !0), flock.audio.encode.setString(d, 8, "WAVE"), flock.audio.encode.setString(d, 12, "fmt "), 
    d.setUint32(16, i, !0), d.setUint16(20, l, !0), d.setUint16(22, o, !0), d.setUint32(24, r, !0), 
    d.setUint32(28, r * s, !0), d.setUint16(32, s, !0), d.setUint16(34, f, !0), 
    36);
    return 3 === l ? (d.setUint16(c, 0, !0), c = flock.audio.encode.wav.writeFactChunk(d, c += 2, e.format.numSampleFrames)) : 65534 === l && (d.setUint16(c, 22, !0), 
    c = flock.audio.encode.wav.additionalFormat(c += 2, d, f, a), c = flock.audio.encode.wav.writeFactChunk(d, c, e.format.numSampleFrames)), 
    flock.audio.encode.wav.writeDataChunk(t, c, d, n, u), d.buffer;
}, flock.audio.encode.wav.subformats = {
    pcm: new Uint8Array([ 1, 0, 0, 0, 0, 0, 16, 0, 128, 0, 0, 170, 0, 56, 155, 113 ]),
    float: new Uint8Array([ 3, 0, 0, 0, 0, 0, 16, 0, 128, 0, 0, 170, 0, 56, 155, 113 ])
}, flock.audio.encode.wav.additionalFormat = function(e, t, n, o) {
    t.setUint16(e, n, !0), t.setUint32(e += 2, 2147483648, !0);
    n = flock.audio.encode.wav.subformats[o ? "pcm" : "float"];
    return flock.audio.encode.setBytes(t, e += 4, n), e += 16;
}, flock.audio.encode.wav.writeFactChunk = function(e, t, n) {
    return flock.audio.encode.setString(e, t, "fact"), e.setUint32(t += 4, 4, !0), 
    e.setUint32(t += 4, n, !0), t += 4;
}, flock.audio.encode.wav.writeDataChunk = function(e, t, n, o, r) {
    flock.audio.encode.setString(n, t, "data"), n.setUint32(t += 4, r, !0), flock.audio.encode.writeAsPCM(e, t += 4, n, o);
}, (flock = (fluid = fluid || require("infusion")).registerNamespace("flock")).shim = {
    URL: "undefined" != typeof window ? window.URL || window.webkitURL || window.msURL : void 0
}, flock.worker = function(e) {
    var t = typeof e;
    if ("function" == t) e = "(" + e.toString() + ")();"; else if ("string" != t) throw new Error("A flock.worker must be initialized with a String or a Function.");
    return t = window.Blob ? (t = new Blob([ e ], {
        type: "text/javascript"
    }), flock.shim.URL.createObjectURL(t)) : "data:text/javascript;base64," + window.btoa(e), 
    new Worker(t);
}, fluid.registerNamespace("flock.scheduler"), fluid.defaults("flock.scheduler.clock", {
    gradeNames: [ "fluid.component" ],
    invokers: {
        end: "fluid.mustBeOverridden"
    },
    events: {
        tick: null
    },
    listeners: {
        "onDestroy.end": "{that}.end()"
    }
}), fluid.defaults("flock.scheduler.intervalClock", {
    gradeNames: [ "flock.scheduler.clock" ],
    members: {
        scheduled: {}
    },
    invokers: {
        schedule: {
            funcName: "flock.scheduler.intervalClock.schedule",
            args: [ "{arguments}.0", "{that}.scheduled", "{that}.events.tick.fire", "{that}.events.onClear.fire" ]
        },
        clear: {
            funcName: "flock.scheduler.intervalClock.clear",
            args: [ "{arguments}.0", "{that}.scheduled", "{that}.events.onClear.fire" ]
        },
        clearAll: {
            funcName: "flock.scheduler.intervalClock.clearAll",
            args: [ "{that}.scheduled", "{that}.events.onClear.fire" ]
        },
        end: "{that}.clearAll"
    }
}), flock.scheduler.intervalClock.schedule = function(e, t, n) {
    var o = setInterval(function() {
        n(e);
    }, e);
    t[e] = o;
}, flock.scheduler.intervalClock.clear = function(e, t) {
    var n = t[e];
    clearInterval(n), delete t[e];
}, flock.scheduler.intervalClock.clearAll = function(e, t) {
    for (var n in e) flock.scheduler.intervalClock.clear(n, e, t);
}, fluid.defaults("flock.scheduler.scheduleClock", {
    gradeNames: [ "flock.scheduler.clock" ],
    members: {
        scheduled: []
    },
    invokers: {
        schedule: {
            funcName: "flock.scheduler.scheduleClock.schedule",
            args: [ "{arguments}.0", "{that}.scheduled", "{that}.events" ]
        },
        clear: {
            funcName: "flock.scheduler.scheduleClock.clear",
            args: [ "{arguments}.0", "{arguments}.1", "{that}.scheduled", "{that}.events.onClear.fire" ]
        },
        clearAll: {
            funcName: "flock.scheduler.scheduleClock.clearAll",
            args: [ "{that}.scheduled", "{that}.events.onClear.fire" ]
        },
        end: "{that}.clearAll"
    }
}), flock.scheduler.scheduleClock.schedule = function(e, t, n) {
    var o = setTimeout(function() {
        clearTimeout(o), n.tick.fire(e);
    }, e);
    t.push(o);
}, flock.scheduler.scheduleClock.clear = function(e, t, n) {
    -1 < (t = void 0 === t ? n.indexOf(e) : t) && (n.splice(t, 1), clearTimeout(e));
}, flock.scheduler.scheduleClock.clearAll = function(e) {
    for (var t = 0; t < e.length; t++) {
        var n = e[t];
        clearTimeout(n);
    }
    e.length = 0;
}, fluid.defaults("flock.scheduler.webWorkerClock", {
    gradeNames: [ "fluid.component" ],
    members: {
        worker: {
            expander: {
                funcName: "flock.worker",
                args: "@expand:fluid.getGlobalValue(flock.scheduler.webWorkerClock.workerImpl)"
            }
        }
    },
    invokers: {
        postToWorker: {
            funcName: "flock.scheduler.webWorkerClock.postToWorker",
            args: [ "{arguments}.0", "{arguments}.1", "{that}.options.messages", "{that}.worker" ]
        },
        schedule: "{that}.postToWorker(schedule, {arguments}.0)",
        clear: "{that}.postToWorker(clear, {arguments}.0)",
        clearAll: "{that}.postToWorker(clearAll)",
        end: "{that}.postToWorker(end)"
    },
    events: {
        tick: null
    },
    listeners: {
        "onCreate.initClock": {
            funcName: "flock.scheduler.webWorkerClock.init",
            args: [ "{that}" ]
        },
        "onDestroy.clearAllScheduled": "{that}.clearAll",
        "onDestroy.endWorker": {
            priority: "after:clearAllScheduled",
            func: "{that}.end"
        }
    },
    startMsg: {
        msg: "start",
        value: "{that}.options.clockType"
    },
    messages: {
        schedule: {
            msg: "schedule"
        },
        clear: {
            msg: "clear"
        },
        clearAll: {
            msg: "clearAll"
        },
        end: {
            msg: "end"
        }
    }
}), flock.scheduler.webWorkerClock.init = function(t) {
    t.worker.addEventListener("message", function(e) {
        t.events.tick.fire(e.data.value);
    }, !1), t.worker.postMessage(t.options.startMsg);
}, flock.scheduler.webWorkerClock.postToWorker = function(e, t, n, o) {
    n = n[e];
    void 0 !== t && (n.value = t), o.postMessage(n);
}, flock.scheduler.webWorkerClock.workerImpl = function() {
    var t = {};
    t.worker = t.worker || {}, t.worker.clock = function() {
        var e = {
            tick: function(e) {
                self.postMessage({
                    msg: "tick",
                    value: e
                });
            }
        };
        return e;
    }, t.worker.intervalClock = function() {
        var n = t.worker.clock();
        return n.scheduled = {}, n.schedule = function(e) {
            var t = setInterval(function() {
                n.tick(e);
            }, e);
            n.scheduled[e] = t;
        }, n.clear = function(e) {
            var t = n.scheduled[e];
            clearInterval(t), delete n.scheduled[e];
        }, n.clearAll = function() {
            for (var e in n.scheduled) n.clear(e);
        }, n;
    }, t.worker.scheduleClock = function() {
        var n = t.worker.clock();
        return n.scheduled = [], n.schedule = function(e) {
            var t = setTimeout(function() {
                n.clear(t), n.tick(e);
            }, e);
            n.scheduled.push(t);
        }, n.clear = function(e, t) {
            -1 < (t = void 0 === t ? n.scheduled.indexOf(e) : t) && n.scheduled.splice(t, 1), 
            clearTimeout(e);
        }, n.clearAll = function() {
            for (var e = 0; e < n.scheduled.length; e++) {
                var t = n.scheduled[e];
                clearTimeout(t);
            }
            n.scheduled.length = 0;
        }, n;
    }, self.addEventListener("message", function(e) {
        "start" === e.data.msg ? t.clock = t.worker[e.data.value]() : "end" === e.data.msg ? t.clock && (t.clock.clearAll(), 
        self.close()) : t.clock && t.clock[e.data.msg](e.data.value);
    }, !1);
}, fluid.defaults("flock.scheduler.webWorkerIntervalClock", {
    gradeNames: [ "flock.scheduler.webWorkerClock" ],
    clockType: "intervalClock"
}), fluid.defaults("flock.scheduler.webWorkerScheduleClock", {
    gradeNames: [ "flock.scheduler.webWorkerClock" ],
    clockType: "scheduleClock"
}), fluid.defaults("flock.scheduler", {
    gradeNames: [ "fluid.component" ],
    events: {
        onScheduled: null,
        onFinished: null,
        onClearAll: null
    },
    listeners: {
        "onClearAll.clearClock": [ "{that}.clock.clearAll()" ]
    }
}), flock.scheduler.addListener = function(e, t, n) {
    return t.push(e), n(e), e;
}, flock.scheduler.removeListener = function(e, t, n) {
    var o;
    e && (-1 < (o = t.indexOf(e)) ? (t.splice(o, 1), n(e)) : e.wrappedListener && flock.scheduler.removeListener(e.wrappedListener, t, n));
}, fluid.defaults("flock.scheduler.repeat", {
    gradeNames: [ "flock.scheduler" ],
    members: {
        listeners: {}
    },
    components: {
        clock: {
            type: "flock.scheduler.webWorkerIntervalClock"
        }
    },
    invokers: {
        schedule: {
            funcName: "flock.scheduler.repeat.schedule",
            args: [ "{arguments}.0", "{arguments}.1", "{timeConverter}", "{synthContext}", "{that}.listeners", "{that}.events.onScheduled.fire" ]
        },
        clear: "{that}.events.onFinished.fire",
        clearAll: {
            funcName: "flock.scheduler.repeat.clearAll",
            args: [ "{that}.listeners", "{that}.events.onFinished.fire", "{that}.events.onClearAll.fire" ]
        },
        clearInterval: {
            funcName: "flock.scheduler.repeat.clearInterval",
            args: [ "{arguments}.0", "{that}.listeners", "{that}.events.onFinished.fire" ]
        },
        addIntervalListener: {
            funcName: "flock.scheduler.repeat.addIntervalListener",
            args: [ "{arguments}.0", "{arguments}.1", "{that}.listeners", "{that}.clock.events.tick.addListener" ]
        },
        removeIntervalListener: {
            funcName: "flock.scheduler.repeat.removeIntervalListener",
            args: [ "{arguments}.0", "{arguments}.1", "{that}.listeners", "{that}.clock.events.tick.removeListener" ]
        }
    },
    listeners: {
        "onScheduled.addIntervalListener": {
            func: "{that}.addIntervalListener",
            args: [ "{arguments}.0", "{arguments}.1" ]
        },
        "onScheduled.scheduleEvent": {
            priority: "after:addIntervalListener",
            func: "{that}.clock.schedule",
            args: [ "{arguments}.0" ]
        },
        "onFinished.removeIntervalListener": {
            func: "{that}.removeIntervalListener",
            args: [ "{arguments}.0", "{arguments}.1" ]
        }
    }
}), flock.scheduler.repeat.intervalListeners = function(e, t) {
    return t[e];
}, flock.scheduler.repeat.addIntervalListener = function(e, t, n, o) {
    e = flock.scheduler.repeat.intervalListeners(e, n);
    flock.scheduler.addListener(t, e, o);
}, flock.scheduler.repeat.removeIntervalListener = function(e, t, n, o) {
    e = flock.scheduler.repeat.intervalListeners(e, n);
    flock.scheduler.removeListener(t, e, o);
}, flock.scheduler.repeat.schedule = function(e, t, n, o, r, a) {
    e = n.value(e), t = flock.scheduler.async.prepareListener(t, o);
    n = flock.scheduler.repeat.wrapValueListener(e, t);
    return flock.scheduler.repeat.addInterval(e, r), a(e, n), n;
}, flock.scheduler.repeat.wrapValueListener = function(t, n) {
    function e(e) {
        e === t && n(e);
    }
    return e.wrappedListener = n, e;
}, flock.scheduler.repeat.addInterval = function(e, t) {
    var n = t[e];
    n || (t[e] = []);
}, flock.scheduler.repeat.clearAll = function(e, t, n) {
    for (var o in e) flock.scheduler.repeat.clearInterval(o, e, t);
    n();
}, flock.scheduler.repeat.clearInterval = function(e, t, n) {
    var o = t[e];
    if (o) for (var r = 0; r < o.length; r++) n(e, o[r]);
}, fluid.defaults("flock.scheduler.once", {
    gradeNames: [ "flock.scheduler" ],
    members: {
        listeners: []
    },
    components: {
        clock: {
            type: "flock.scheduler.webWorkerScheduleClock"
        }
    },
    invokers: {
        schedule: {
            funcName: "flock.scheduler.once.schedule",
            args: [ "{arguments}.0", "{arguments}.1", "{timeConverter}", "{synthContext}", "{that}.clear", "{that}.events.onScheduled.fire" ]
        },
        clear: "{that}.events.onFinished.fire",
        clearAll: {
            funcName: "flock.scheduler.once.clearAll",
            args: [ "{that}.listeners", "{that}.events.onFinished.fire", "{that}.events.onClearAll.fire" ]
        }
    },
    listeners: {
        "onScheduled.addListener": {
            funcName: "flock.scheduler.addListener",
            args: [ "{arguments}.1", "{that}.listeners", "{that}.clock.events.tick.addListener" ]
        },
        "onScheduled.scheduleEvent": {
            func: "{that}.clock.schedule",
            args: [ "{arguments}.0" ]
        },
        "onFinished.removeListener": {
            funcName: "flock.scheduler.removeListener",
            args: [ "{arguments}.0", "{that}.listeners", "{that}.clock.events.tick.removeListener" ]
        }
    }
}), flock.scheduler.once.wrapValueListener = function(t, n, o) {
    function r(e) {
        e === t && (n(e), o(r));
    }
    return r.wrappedListener = n, r;
}, flock.scheduler.once.schedule = function(e, t, n, o, r, a) {
    e = n.value(e), t = flock.scheduler.async.prepareListener(t, o);
    n = flock.scheduler.once.wrapValueListener(e, t, r);
    return a(e, n), n;
}, flock.scheduler.once.clearAll = function(e, t, n) {
    for (var o = 0; o < e.length; o++) t(e[o]);
    n();
}, fluid.defaults("flock.scheduler.async", {
    gradeNames: [ "fluid.component" ],
    subSchedulerOptions: {
        components: {
            timeConverter: "{async}.timeConverter"
        },
        listeners: {
            "{async}.events.onClear": "{that}.clear()",
            "{async}.events.onClearAll": "{that}.clearAll()",
            "{async}.events.onEnd": "{that}.clock.end()"
        }
    },
    distributeOptions: {
        source: "{that}.options.subSchedulerOptions",
        removeSource: !0,
        target: "{that flock.scheduler}.options"
    },
    components: {
        timeConverter: {
            type: "flock.convert.seconds"
        },
        onceScheduler: {
            type: "flock.scheduler.once"
        },
        repeatScheduler: {
            type: "flock.scheduler.repeat"
        },
        synthContext: void 0
    },
    invokers: {
        repeat: {
            func: "{repeatScheduler}.schedule",
            args: [ "{arguments}.0", "{arguments}.1" ]
        },
        once: {
            func: "{onceScheduler}.schedule",
            args: [ "{arguments}.0", "{arguments}.1" ]
        },
        sequence: {
            funcName: "flock.scheduler.async.sequence",
            args: [ "{arguments}.0", "{arguments}.1", "{that}.once" ]
        },
        schedule: {
            funcName: "flock.scheduler.async.schedule",
            args: [ "{arguments}.0", "{that}" ]
        },
        clear: "{that}.events.onClear.fire",
        clearAll: "{that}.events.onClearAll.fire",
        end: "{that}.events.onEnd.fire"
    },
    events: {
        onClear: null,
        onClearAll: null,
        onEnd: null
    },
    listeners: {
        "onCreate.scheduleScore": "{that}.schedule({that}.options.score)",
        "onEnd.clearAllEvents": "{that}.clearAll"
    }
}), flock.scheduler.async.sequence = function(e, t, n) {
    for (var o = [], r = 0; r < e.length; r++) {
        var a = n(e[r], t);
        o.push(a);
    }
    return o;
}, flock.scheduler.async.schedule = function(e, t) {
    if (e) {
        e = flock.isIterable(e) ? e : [ e ];
        for (var n = 0; n < e.length; n++) {
            var o = e[n];
            flock.invoke(t, o.interval, [ o.time, o.change ]);
        }
    }
}, flock.scheduler.async.prepareListener = function(e, t) {
    return "function" == typeof e ? e : flock.scheduler.async.evaluateChangeSpec(e, t);
}, flock.scheduler.async.getTargetSynth = function(e, t) {
    e = e.synth;
    return e ? "string" != typeof e ? e : fluid.get(t, e) : t;
}, flock.scheduler.async.makeSynthUpdater = function(o, r, a, i) {
    return function() {
        for (var e in o) {
            var t = o[e];
            a[e] = flock.evaluate.synthValue(t);
        }
        var n = flock.scheduler.async.getTargetSynth(r, i);
        n ? n.set(a) : flock.fail("A target synth named " + r.synth + " could not be found in the specified synthContext. Synth context was: " + i);
    };
}, flock.scheduler.async.evaluateChangeSpec = function(e, t) {
    var n, o = {}, r = {};
    for (n in e.values) {
        var a = e.values[n];
        a.synthDef ? o[n] = flock.synth.value(a) : r[n] = a;
    }
    return flock.scheduler.async.makeSynthUpdater(o, e, r, t);
}, fluid.defaults("flock.scheduler.async.tempo", {
    gradeNames: [ "flock.scheduler.async" ],
    bpm: 60,
    components: {
        timeConverter: {
            type: "flock.convert.beats",
            options: {
                bpm: "{tempo}.options.bpm"
            }
        }
    }
}), fluid.registerNamespace("flock.convert"), fluid.defaults("flock.convert.ms", {
    gradeNames: [ "fluid.component" ],
    invokers: {
        value: "fluid.identity({arguments}.0)"
    }
}), fluid.defaults("flock.convert.seconds", {
    gradeNames: [ "fluid.component" ],
    invokers: {
        value: "flock.convert.seconds.toMillis({arguments}.0)"
    }
}), flock.convert.seconds.toMillis = function(e) {
    return 1e3 * e;
}, fluid.defaults("flock.convert.beats", {
    gradeNames: [ "fluid.component" ],
    bpm: 60,
    invokers: {
        value: "flock.convert.beats.toMillis({arguments}.0, {that}.options.bpm)"
    }
}), flock.convert.beats.toMillis = function(e, t) {
    return t <= 0 ? 0 : e / t * 6e4;
};

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

fluid.registerNamespace("flock.webAudio"), flock.webAudio.createNode = function(e, t) {
    var n = t.args ? fluid.makeArray(t.args) : void 0, o = "create" + t.node, r = o.indexOf("Node"), r = e[o = -1 < r ? o.substring(0, r) : o].apply(e, n);
    return flock.webAudio.initNodeParams(e, r, t), flock.webAudio.initNodeProperties(r, t), 
    flock.webAudio.initNodeInputs(r, t), r;
}, flock.webAudio.setAudioParamValue = function(e, t, n, o) {
    e = e.currentTime + (o = o || 0);
    t.setValueAtTime(n, e);
}, flock.webAudio.initNodeParams = function(e, t, n) {
    var o = n.params;
    if (t && o) {
        for (var r in o) {
            var a = t[r], r = o[r];
            flock.webAudio.setAudioParamValue(e, a, r);
        }
        return t;
    }
}, flock.webAudio.safariPropertyProhibitions = [ "channelCount", "channelCountMode" ], 
flock.webAudio.shouldSetProperty = function(e) {
    return !flock.platform.browser.safari || flock.webAudio.safariPropertyProhibitions.indexOf(e) < 0;
}, flock.webAudio.initNodeProperties = function(e, t) {
    var n = t.props;
    if (n) {
        for (var o in n) {
            var r = n[o];
            flock.webAudio.shouldSetProperty(o) && (e[o] = r);
        }
        return e;
    }
}, flock.webAudio.connectInput = function(e, t, n, o) {
    n.connect(e, o, t);
}, flock.webAudio.initNodeInputs = function(e, t) {
    var n, o = t.inputs;
    for (n in o) for (var r = o[n], a = parseInt(n, 10), r = fluid.makeArray(r), i = 0; i < r.length; i++) {
        var l = r[i];
        flock.webAudio.connectInput(e, a, l);
    }
}, fluid.defaults("flock.webAudio.node", {
    gradeNames: [ "fluid.modelComponent" ],
    members: {
        node: "@expand:flock.webAudio.createNode({audioSystem}.context, {that}.options.nodeSpec)"
    },
    nodeSpec: {
        args: [],
        params: {},
        properties: {}
    }
}), fluid.defaults("flock.webAudio.gain", {
    gradeNames: [ "flock.webAudio.node" ],
    members: {
        node: "@expand:flock.webAudio.createNode({audioSystem}.context, {that}.options.nodeSpec)"
    },
    nodeSpec: {
        node: "Gain"
    }
}), fluid.defaults("flock.webAudio.scriptProcessor", {
    gradeNames: [ "flock.webAudio.node" ],
    nodeSpec: {
        node: "ScriptProcessor",
        args: [ "{audioSystem}.model.bufferSize", "{audioSystem}.model.numInputBuses", "{audioSystem}.model.chans" ],
        params: {},
        properties: {
            channelCountMode: "explicit"
        }
    }
}), fluid.defaults("flock.webAudio.channelMerger", {
    gradeNames: [ "flock.webAudio.node" ],
    nodeSpec: {
        node: "ChannelMerger",
        args: [ "{audioSystem}.model.numInputBuses" ],
        properties: {
            channelCountMode: "discrete"
        }
    }
}), fluid.defaults("flock.webAudio.outputFader", {
    gradeNames: [ "fluid.component" ],
    fadeDuration: .5,
    gainSpec: {
        node: "Gain",
        params: {
            gain: 0
        },
        properties: {
            channelCount: "{flock.enviro}.audioSystem.model.chans",
            channelCountMode: "explicit"
        }
    },
    members: {
        gainNode: "@expand:flock.webAudio.outputFader.createGainNode({flock.enviro}.audioSystem.nativeNodeManager, {that}.options.gainSpec)",
        context: "{flock.enviro}.audioSystem.context"
    },
    invokers: {
        fadeIn: {
            funcName: "flock.webAudio.outputFader.fadeIn",
            args: [ "{that}.context", "{that}.gainNode", "{arguments}.0", "{that}.options.fadeDuration" ]
        },
        fadeTo: {
            funcName: "flock.webAudio.outputFader.fadeTo",
            args: [ "{that}.context", "{that}.gainNode", "{arguments}.0", "{that}.options.fadeDuration" ]
        }
    }
}), flock.webAudio.outputFader.createGainNode = function(e, t) {
    return e.createOutputNode(t);
}, flock.webAudio.outputFader.fade = function(e, t, n, o, r) {
    r = e.currentTime + (r = r || 0);
    flock.webAudio.setAudioParamValue(e, t.gain, n), t.gain.linearRampToValueAtTime(o, r);
}, flock.webAudio.outputFader.fadeTo = function(e, t, n, o) {
    flock.webAudio.outputFader.fade(e, t, t.gain.value, n, o);
}, flock.webAudio.outputFader.fadeIn = function(e, t, n, o) {
    flock.webAudio.outputFader.fade(e, t, 0, n, o);
};

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

fluid.defaults("flock.webAudio.audioSystem", {
    gradeNames: [ "flock.audioSystem" ],
    channelRange: {
        min: "@expand:flock.webAudio.audioSystem.calcMinChannels()",
        max: "@expand:flock.webAudio.audioSystem.calcMaxChannels({that}.context.destination)"
    },
    members: {
        context: "@expand:flock.webAudio.audioSystem.createContext()"
    },
    model: {
        rates: {
            audio: "{that}.context.sampleRate"
        },
        channelCountMode: "explicit",
        channelInterpretation: "discrete"
    },
    modelListeners: {
        chans: {
            funcName: "flock.webAudio.audioSystem.configureDestination",
            args: [ "{that}.context.destination", "channelCount", "{change}.value" ]
        },
        channelCountMode: {
            funcName: "flock.webAudio.audioSystem.configureDestination",
            args: [ "{that}.context.destination", "channelCountMode", "{change}.value" ]
        },
        channelInterpretation: {
            funcName: "flock.webAudio.audioSystem.configureDestination",
            args: [ "{that}.context.destination", "channelInterpretation", "{change}.value" ]
        }
    },
    components: {
        outputManager: {
            type: "flock.webAudio.outputManager"
        },
        nativeNodeManager: {
            type: "flock.webAudio.nativeNodeManager"
        },
        inputDeviceManager: {
            type: "flock.webAudio.inputDeviceManager"
        },
        bufferWriter: {
            type: "flock.webAudio.bufferWriter"
        }
    }
}), flock.webAudio.audioSystem.createContext = function() {
    var e = flock.webAudio.audioSystem;
    return e.audioContextSingleton || (e.audioContextSingleton = new flock.shim.AudioContext()), 
    e.audioContextSingleton;
}, flock.webAudio.audioSystem.calcMaxChannels = function(e) {
    return flock.platform.browser.safari ? e.channelCount : e.maxChannelCount;
}, flock.webAudio.audioSystem.calcMinChannels = function() {
    return flock.platform.browser.safari ? 2 : 1;
}, flock.webAudio.audioSystem.configureDestination = function(e, t, n) {
    flock.platform.browser.safari || void 0 === n || (e[t] = n);
}, fluid.defaults("flock.webAudio.enviroContextDistributor", {
    gradeNames: [ "fluid.component" ],
    distributeOptions: [ {
        target: "{/ flock.enviro > audioSystem}.options",
        record: {
            gradeNames: "flock.webAudio.audioSystem"
        }
    } ]
}), fluid.constructSingle([], {
    singleRootType: "flock.enviroContextDistributor",
    type: "flock.webAudio.enviroContextDistributor"
});

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

fluid.defaults("flock.webAudio.bufferWriter", {
    gradeNames: "fluid.component",
    invokers: {
        save: "flock.webAudio.bufferWriter.saveBuffer({arguments}.0)"
    }
}), flock.webAudio.bufferWriter.saveBuffer = function(t) {
    try {
        var e = flock.audio.encode.wav(t.buffer, t.format), n = new Blob([ e ], {
            type: "audio/wav"
        });
        return flock.webAudio.bufferWriter.download(t.path, n), t.success && t.success(e), 
        e;
    } catch (e) {
        t.error ? t.error(e) : flock.fail("There was an error while trying to download the buffer named " + t.buffer.id + ". Error: " + e);
    }
}, flock.webAudio.bufferWriter.download = function(e, t) {
    var t = flock.shim.URL.createObjectURL(t), n = window.document.createElement("a"), o = document.createEvent("Event");
    n.href = t, n.download = e, o.initEvent("click", !0, !0), n.dispatchEvent(o);
};

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

!function() {
    fluid.registerNamespace("flock.webAudio.chrome"), flock.webAudio.chrome.getSources = function(t) {
        return MediaStreamTrack.getSources(function(e) {
            e = fluid.transform(e, function(e) {
                return e.deviceId = e.id, e;
            });
            t(e);
        });
    }, flock.webAudio.mediaStreamFailure = function(e) {
        var t = "This browser does not support getUserMedia() or the Media Streams API.";
        e ? e(new Error(t)) : fluid.log(fluid.logLevel.IMPORTANT, t);
    };
    var e = {
        AudioContext: window.AudioContext || window.webkitAudioContext,
        getUserMedia: function(e, t, n) {
            navigator.mediaDevices ? navigator.mediaDevices.getUserMedia(e).then(t).catch(n) : navigator.getUserMedia ? navigator.getUserMedia(e, t, n) : flock.webAudio.mediaStreamFailure(n);
        },
        getMediaDevicesImpl: navigator.getMediaDevices || (void 0 !== window.MediaStreamTrack ? flock.webAudio.chrome.getSources : flock.webAudio.mediaStreamFailure),
        getMediaDevice: function() {
            flock.shim.getMediaDevicesImpl.apply(navigator, arguments);
        }
    };
    jQuery.extend(flock.shim, e), fluid.defaults("flock.webAudio.inputDeviceManager", {
        gradeNames: [ "fluid.component" ],
        invokers: {
            openAudioDevice: {
                funcName: "flock.webAudio.inputDeviceManager.openAudioDevice",
                args: [ "{arguments}.0", "{that}.openAudioDeviceWithId", "{that}.openFirstAudioDeviceWithLabel", "{that}.openAudioDeviceWithConstraints" ]
            },
            openAudioDeviceWithConstraints: {
                funcName: "flock.webAudio.inputDeviceManager.openAudioDeviceWithConstraints",
                args: [ "{audioSystem}.context", "{enviro}", "{nativeNodeManager}.createMediaStreamInput", "{arguments}.0" ]
            },
            openAudioDeviceWithId: {
                funcName: "flock.webAudio.inputDeviceManager.openAudioDeviceWithId",
                args: [ "{arguments}.0", "{that}.openAudioDeviceWithConstraints" ]
            },
            openFirstAudioDeviceWithLabel: {
                funcName: "flock.webAudio.inputDeviceManager.openFirstAudioDeviceWithLabel",
                args: [ "{arguments}.0", "{that}.openAudioDeviceWithId" ]
            }
        }
    }), flock.webAudio.inputDeviceManager.openAudioDevice = function(e, t, n, o) {
        if (e) {
            if (e.id) return t(e.id);
            if (e.label) return n(e.label);
        }
        return o();
    }, flock.webAudio.inputDeviceManager.openAudioDeviceWithId = function(e, t) {
        t({
            audio: {
                optional: [ {
                    sourceId: e
                } ]
            }
        });
    }, flock.webAudio.inputDeviceManager.openFirstAudioDeviceWithLabel = function(t, n) {
        t && flock.shim.getMediaDevices(function(e) {
            e = e.filter(function(e) {
                if (e.label.toLowerCase() === t.toLowerCase()) return !0;
            });
            0 < e.length ? n(e[0].deviceId) : fluid.log(fluid.logLevel.IMPORTANT, "An audio device named '" + t + "' could not be found.");
        });
    }, flock.webAudio.inputDeviceManager.openAudioDeviceWithConstraints = function(e, t, n, o) {
        o = o || {
            audio: !0
        };
        var r = t.busManager.acquireNextBus("input");
        return flock.shim.getUserMedia(o, function(e) {
            n(e, r);
        }, function(e) {
            fluid.log(fluid.logLevel.IMPORTANT, "An error occurred while trying to access the user's microphone. " + e);
        }), r;
    };
}();

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

fluid.defaults("flock.webAudio.nativeNodeManager", {
    gradeNames: [ "fluid.component" ],
    members: {
        outputNode: void 0,
        inputNodes: []
    },
    components: {
        scriptProcessor: {
            createOnEvent: "onCreateScriptProcessor",
            type: "flock.webAudio.scriptProcessor",
            options: {
                nodeSpec: {
                    inputs: {
                        0: "{inputMerger}"
                    }
                }
            }
        },
        merger: {
            type: "flock.webAudio.channelMerger"
        }
    },
    invokers: {
        connect: "{that}.events.onConnect.fire",
        disconnect: "{that}.events.onDisconnect.fire",
        createNode: {
            funcName: "flock.webAudio.createNode",
            args: [ "{audioSystem}.context", "{arguments}.0" ]
        },
        createInputNode: {
            funcName: "flock.webAudio.nativeNodeManager.createInputNode",
            args: [ "{that}", "{arguments}.0", "{arguments}.1" ]
        },
        createMediaStreamInput: {
            funcName: "flock.webAudio.nativeNodeManager.createInputNode",
            args: [ "{that}", {
                node: "MediaStreamSource",
                args: [ "{arguments}.0" ]
            }, "{arguments}.1" ]
        },
        createMediaElementInput: {
            funcName: "flock.webAudio.nativeNodeManager.createInputNode",
            args: [ "{that}", {
                node: "MediaElementSource",
                args: [ "{arguments}.0" ]
            }, "{arguments}.1" ]
        },
        createOutputNode: {
            funcName: "flock.webAudio.nativeNodeManager.createOutputNode",
            args: [ "{that}", "{arguments}.0" ]
        },
        insertInput: {
            funcName: "flock.webAudio.nativeNodeManager.insertInput",
            args: [ "{that}", "{audioSystem}.model", "{enviro}", "{arguments}.0", "{arguments}.1" ]
        },
        removeInput: {
            funcName: "flock.webAudio.nativeNodeManager.removeInput",
            args: [ "{arguments}.0", "{that}.inputNodes" ]
        },
        removeAllInputs: {
            funcName: "flock.webAudio.nativeNodeManager.removeAllInputs",
            args: "{that}.inputNodes"
        },
        insertOutput: {
            funcName: "flock.webAudio.nativeNodeManager.insertOutput",
            args: [ "{that}", "{arguments}.0" ]
        },
        removeOutput: {
            funcName: "flock.webAudio.nativeNodeManager.removeOutput",
            args: [ "{scriptProcessor}.node" ]
        }
    },
    events: {
        onStart: "{enviro}.events.onStart",
        onStop: "{enviro}.events.onStop",
        onReset: "{enviro}.events.onReset",
        onCreateScriptProcessor: null,
        onConnect: null,
        onDisconnectNodes: null,
        onDisconnect: null
    },
    listeners: {
        "onCreate.fireOnCreateScriptProcessor": {
            func: "{that}.events.onCreateScriptProcessor.fire"
        },
        "onCreate.insertOutputNode": {
            priority: "after:fireOnCreateScriptProcessor",
            func: "{that}.insertOutput",
            args: "{scriptProcessor}.node"
        },
        "onStart.connect": "{that}.connect()",
        "onConnect.connectMergerNode": {
            this: "{merger}.node",
            method: "connect",
            args: [ "{scriptProcessor}.node" ]
        },
        "onConnect.connectOutputNode": {
            priority: "after:connectMergerNode",
            this: "{that}.outputNode",
            method: "connect",
            args: [ "{audioSystem}.context.destination" ]
        },
        "onConnect.connectOutput": {
            priority: "after:connectOutputNode",
            funcName: "flock.webAudio.nativeNodeManager.connectOutput",
            args: [ "{scriptProcessor}.node", "{that}.outputNode" ]
        },
        "onStop.disconnect": "{that}.disconnect()",
        "onDisconnect.fireOnDisconnectNodes": {
            func: "{that}.events.onDisconnectNodes.fire"
        },
        "onDisconnectNodes.disconnectMergerNode": {
            this: "{merger}.node",
            method: "disconnect",
            args: [ 0 ]
        },
        "onDisconnect.disconnectScriptProcessorNode": {
            priority: "after:disconnectMergerNode",
            this: "{scriptProcessor}.node",
            method: "disconnect",
            args: [ 0 ]
        },
        "onDisconnectNodes.disconnectOuptutNode": {
            priority: "after:disconnectScriptProcessorNode",
            this: "{that}.outputNode",
            method: "disconnect",
            args: [ 0 ]
        },
        "onReset.removeAllInputs": {
            func: "{that}.removeAllInputs"
        },
        "onReset.fireOnCreateScriptProcessor": {
            func: "{that}.events.onCreateScriptProcessor.fire"
        },
        "onDestroy.fireOnDisconnectNodes": {
            func: "{that}.events.onDisconnectNodes.fire"
        },
        "onDestroy.removeAllInputs": {
            priority: "after:fireOnDisconnectNodes",
            func: "{that}.removeAllInputs"
        },
        "onDestroy.disconnectOutput": {
            priority: "after:removeAllInputs",
            func: "flock.webAudio.nativeNodeManager.disconnectOutput",
            args: [ "{that}" ]
        }
    }
}), flock.webAudio.nativeNodeManager.createInputNode = function(e, t, n) {
    t = e.createNode(t);
    return e.insertInput(t, n);
}, flock.webAudio.nativeNodeManager.createOutputNode = function(e, t) {
    t = e.createNode(t);
    return e.insertOutput(t);
}, flock.webAudio.nativeNodeManager.connectOutput = function(e, t) {
    e !== t && e.connect(t);
}, flock.webAudio.nativeNodeManager.disconnectOutput = function(e) {
    e.outputNode && e.outputNode.disconnect(0);
}, flock.webAudio.nativeNodeManager.removeAllInputs = function(e) {
    for (var t = 0; t < e.length; t++) e[t].disconnect(0);
    e.length = 0;
}, flock.webAudio.nativeNodeManager.insertInput = function(e, t, n, o, r) {
    var a = t.numInputBuses;
    {
        if (!(e.inputNodes.length >= a)) return a = (r = void 0 === r ? n.busManager.acquireNextBus("input") : r) - t.chans, 
        e.inputNodes.push(o), o.connect(e.merger.node, 0, a), r;
        flock.fail("There are too many input nodes connected to Flocking. The maximum number of input buses is currently set to " + a + ". Either remove an existing input node or increase Flockings numInputBuses option.");
    }
}, flock.webAudio.nativeNodeManager.removeInput = function(e, t) {
    var n = t.indexOf(e);
    -1 < n && t.splice(n, 1), e.disconnect(0);
}, flock.webAudio.nativeNodeManager.insertOutput = function(e, t) {
    return flock.webAudio.nativeNodeManager.disconnectOutput(e), e.outputNode = t;
}, flock.webAudio.nativeNodeManager.removeOutput = function(e) {
    flock.webAudio.nativeNodeManager.insertOutput(e);
};

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

fluid.defaults("flock.webAudio.outputManager", {
    gradeNames: [ "flock.outputManager" ],
    model: {
        isGenerating: !1,
        audioSettings: {}
    },
    invokers: {
        bindAudioProcess: {
            funcName: "flock.webAudio.outputManager.bindAudioProcess",
            args: [ "{enviro}.nodeList", "{busManager}.buses", "{nativeNodeManager}", "{that}.model" ]
        },
        unbindAudioProcess: {
            funcName: "flock.webAudio.outputManager.unbindAudioProcess",
            args: [ "{nativeNodeManager}" ]
        }
    },
    listeners: {
        "{nativeNodeManager}.events.onConnect": [ "{that}.bindAudioProcess()" ],
        "{nativeNodeManager}.events.onDisconnect": [ "{that}.unbindAudioProcess()" ],
        onStart: [ {
            func: "{that}.applier.change",
            args: [ "isGenerating", !0 ]
        }, {
            priority: "last",
            this: "{audioSystem}.context",
            method: "resume"
        } ],
        onStop: [ {
            func: "{that}.applier.change",
            args: [ "isGenerating", !1 ]
        } ],
        "onDestroy.unbindAudioProcess": "{that}.unbindAudioProcess()"
    }
}), flock.webAudio.outputManager.bindAudioProcess = function(e, t, n, o) {
    var r = n.scriptProcessor.node;
    r.model = o, r.nodeList = e, r.buses = t, r.inputNodes = n.inputNodes, r.onaudioprocess = flock.webAudio.outputManager.writeSamples;
}, flock.webAudio.outputManager.unbindAudioProcess = function(e) {
    e.scriptProcessor.node.onaudioprocess = void 0;
}, flock.webAudio.outputManager.writeSamples = function(e) {
    var t, n, o = this.inputNodes ? this.inputNodes.length : 0, r = this.nodeList.nodes, a = this.model.audioSettings, i = e.inputBuffer, l = e.outputBuffer, u = a.numBlocks, s = this.buses, f = a.numBuses, c = a.blockSize, d = a.chans, h = i.numberOfChannels;
    if (r.length < 1) for (t = 0; t < d; t++) flock.clearBuffer(l.getChannelData(t)); else for (n = 0; n < u; n++) {
        var m = n * c;
        if (flock.evaluate.clearBuses(s, f, c), 0 < o) for (t = 0; t < h; t++) for (var p = i.getChannelData(t), g = s[d + t], k = 0; k < c; k++) g[k] = p[k + m];
        for (flock.evaluate.synths(r), t = 0; t < d; t++) {
            var v = s[t], b = l.getChannelData(t);
            for (k = 0; k < c; k++) b[k + m] = v[k];
        }
    }
};

flock = (fluid = fluid || require("infusion")).registerNamespace("flock");

!function() {
    var a = fluid.registerNamespace("jQuery");
    flock.ugenDefaults = function(e, t) {
        return 1 === arguments.length ? flock.ugenDefaults.store[e] : flock.ugenDefaults.store[e] = t;
    }, flock.ugenDefaults.store = {}, flock.isUGen = function(e) {
        return e && e.tags && -1 < e.tags.indexOf("flock.ugen");
    }, flock.aliasUGen = function(e, t, n, o) {
        var r = flock.get(e);
        flock.set(r, t, function(e, t, n) {
            return n = a.extend(!0, {}, o, n), r(e, t, n);
        }), flock.ugenDefaults(e + "." + t, n);
    }, flock.aliasUGens = function(e, t) {
        var n, o;
        for (n in t) o = t[n], flock.aliasUGen(e, n, {
            inputs: o.inputDefaults
        }, o.options);
    }, flock.copyUGenDefinition = function(e, t) {
        var n = flock.ugenDefaults(e), e = fluid.getGlobalValue(e);
        fluid.setGlobalValue(t, e), flock.ugenDefaults(t, fluid.copy(n));
    }, flock.krMul = function(e, t, n) {
        for (var o = n.output[0], r = 0; r < e; r++) t[r] = t[r] * o;
    }, flock.mul = function(e, t, n) {
        for (var o = n.output, r = 0; r < e; r++) t[r] = t[r] * o[r];
    }, flock.krAdd = function(e, t, n, o) {
        for (var r = o.output[0], a = 0; a < e; a++) t[a] = t[a] + r;
    }, flock.add = function(e, t, n, o) {
        for (var r = o.output, a = 0; a < e; a++) t[a] = t[a] + r[a];
    }, flock.krMulAdd = function(e, t, n, o) {
        for (var r = n.output[0], a = o.output, i = 0; i < e; i++) t[i] = t[i] * r + a[i];
    }, flock.mulKrAdd = function(e, t, n, o) {
        for (var r = n.output, a = o.output[0], i = 0; i < e; i++) t[i] = t[i] * r[i] + a;
    }, flock.krMulKrAdd = function(e, t, n, o) {
        for (var r = n.output[0], a = o.output[0], i = 0; i < e; i++) t[i] = t[i] * r + a;
    }, flock.mulAdd = function(e, t, n, o) {
        for (var r = n.output, a = o.output, i = 0; i < e; i++) t[i] = t[i] * r[i] + a[i];
    }, flock.onMulAddInputChanged = function(t) {
        var e = t.inputs.mul, n = t.inputs.add;
        e || n ? (e = e ? n ? e.rate !== flock.rates.AUDIO ? n.rate !== flock.rates.AUDIO ? flock.krMulKrAdd : flock.krMulAdd : n.rate !== flock.rates.AUDIO ? flock.mulKrAdd : flock.mulAdd : e.rate !== flock.rates.AUDIO ? flock.krMul : flock.mul : n.rate !== flock.rates.AUDIO ? flock.krAdd : flock.add, 
        t.mulAddFn = e, t.mulAdd = function(e) {
            t.mulAddFn(e, t.output, t.inputs.mul, t.inputs.add);
        }) : t.mulAdd = t.mulAddFn = flock.noOp;
    }, flock.ugen = function(e, t, n) {
        var i = {
            enviro: (n = n || {}).enviro || flock.environment,
            rate: n.rate || flock.rates.AUDIO,
            inputs: e,
            output: t,
            options: n,
            model: n.model || {
                unscaledValue: 0,
                value: 0
            },
            multiInputs: {},
            tags: [ "flock.ugen" ]
        };
        return i.lastOutputIdx = i.output.length - 1, i.get = function(e) {
            return flock.input.get(i.inputs, e);
        }, i.set = function(e, t) {
            return flock.input.set(i.inputs, e, t, i, function(e) {
                if (null != e) return flock.parse.ugenDef(e, i.enviro, {
                    audioSettings: i.options.audioSettings,
                    buses: i.buses,
                    buffers: i.buffers
                });
            });
        }, i.input = function(e, t) {
            return e ? "string" == typeof e ? arguments.length < 2 ? i.get(e) : i.set(e, t) : flock.isIterable(e) ? i.get(e) : i.set(e, t) : void 0;
        }, i.calculateStrides = function() {
            var e, t, n, o = i.model, r = i.options.strideInputs, a = i.inputs;
            if (o.strides = o.strides || {}, r) for (e = 0; e < r.length; e++) (n = a[t = r[e]]) ? o.strides[t] = n.rate === flock.rates.AUDIO ? 1 : 0 : fluid.log(fluid.logLevel.WARN, "An invalid input ('" + t + "') was found on a unit generator: " + i);
        }, i.collectMultiInputs = function() {
            for (var e, t, n = i.options.multiInputNames, o = i.multiInputs, r = 0; r < n.length; r++) (e = o[t = n[r]]) ? e.length = 0 : e = o[t] = [], 
            t = i.inputs[t], flock.ugen.collectMultiInputs(t, e);
        }, i.onInputChanged = function(e) {
            var t = i.options.multiInputNames;
            flock.onMulAddInputChanged(i), i.options.strideInputs && i.calculateStrides(), 
            !t || e && !t.indexOf(e) || i.collectMultiInputs();
        }, i.init = function() {
            for (var e, t = fluid.makeArray(i.options.tags), n = i.model, o = i.options, r = 0; r < t.length; r++) i.tags.push(t[r]);
            e = o.audioSettings = o.audioSettings || i.enviro.audioSystem.model, 
            n.sampleRate = o.sampleRate || e.rates[i.rate], n.nyquistRate = n.sampleRate, 
            n.blockSize = i.rate === flock.rates.AUDIO ? e.blockSize : 1, n.sampleDur = 1 / n.sampleRate, 
            i.interpolate = flock.interpolate.none, o.interpolation && ((e = flock.interpolate[o.interpolation]) ? i.interpolate = e : fluid.log(fluid.logLevel.IMPORTANT, "An invalid interpolation type of '" + o.interpolation + "' was specified. Defaulting to none.")), 
            i.rate === flock.rates.DEMAND && i.inputs.freq && (n = flock.parse.ugenDefForConstantValue(1), 
            i.inputs.freq = flock.parse.ugenDef(n, i.enviro));
        }, i.init(), i;
    }, flock.ugen.collectMultiInputs = function(e, t) {
        flock.isIterable(e) || (e = fluid.makeArray(e));
        for (var n = 0; n < e.length; n++) {
            var o = e[n];
            flock.ugen.collectChannelsForInput(o, t);
        }
        return t;
    }, flock.ugen.collectChannelsForInput = function(e, t) {
        for (var n = flock.hasTag(e, "flock.ugen.multiChannelOutput") ? e.output : [ e.output ], o = 0; o < n.length; o++) t.push({
            rate: e.rate,
            output: n[o]
        });
        return t;
    }, flock.ugen.lastOutputValue = function(e, t) {
        return t[e - 1];
    }, flock.ugen.buffer = function(o) {
        o.onBufferInputChanged = function(e) {
            var t = o.model, n = o.inputs;
            t.bufDef === n.buffer && "buffer" !== e || (t.bufDef = n.buffer, flock.parse.bufferForDef(t.bufDef, o, o.enviro));
        }, o.setBuffer = function(e) {
            o.buffer = e, o.onBufferReady && o.onBufferReady(e);
        }, o.initBuffer = function() {
            o.buffer = o.model.bufDef = flock.bufferDesc({
                format: {
                    sampleRate: o.options.audioSettings.rates.audio
                },
                data: {
                    channels: [ new Float32Array(o.output.length) ]
                }
            });
        };
    }, flock.ugen.value = function(e, t, n) {
        var r = flock.ugen(e, t, n);
        return r.value = function() {
            return r.model.value;
        }, r.dynamicGen = function(e) {
            for (var t = r.output, n = r.model, o = 0; o < e; o++) t[o] = n.unscaledValue;
            r.mulAdd(e), n.value = flock.ugen.lastOutputValue(e, t);
        }, r.onInputChanged = function() {
            var e = r.inputs;
            r.model.unscaledValue = e.value, "constant" !== r.rate ? r.gen = r.dynamicGen : r.gen = void 0, 
            flock.onMulAddInputChanged(r), r.dynamicGen(1);
        }, r.onInputChanged(), r;
    }, flock.ugenDefaults("flock.ugen.value", {
        rate: "control",
        inputs: {
            value: 1,
            mul: null,
            add: null
        },
        ugenOptions: {
            model: {
                unscaledValue: 1,
                value: 1
            },
            tags: [ "flock.ugen.valueType" ]
        }
    }), flock.ugen.silence = function(e, t, n) {
        var o = flock.ugen(e, t, n);
        return o.onInputChanged = function() {
            for (var e = 0; e < o.output.length; e++) o.output[e] = 0;
        }, o.onInputChanged(), o;
    }, flock.ugenDefaults("flock.ugen.silence", {
        rate: "constant"
    }), flock.ugen.passThrough = function(e, t, n) {
        var i = flock.ugen(e, t, n);
        return i.gen = function(e) {
            for (var t, n = i.model, o = i.inputs.source.output, r = i.output, a = 0; a < o.length; a++) r[a] = t = o[a];
            for (;a < e; a++) r[a] = t = 0;
            n.unscaledValue = t, i.mulAdd(e), n.value = flock.ugen.lastOutputValue(e, r);
        }, i.onInputChanged(), i;
    }, flock.ugenDefaults("flock.ugen.passThrough", {
        rate: "audio",
        inputs: {
            source: null,
            mul: null,
            add: null
        }
    }), flock.ugen.out = function(e, t, n) {
        var g = flock.ugen(e, t, n);
        return g.gen = function(e) {
            var t, n, o, r, a, i, l, u, s = g.model, f = g.multiInputs.sources, c = g.options.buses, d = g.inputs.bus.output[0], h = g.inputs.expand.output[0], m = f.length, p = Math.max(h, m);
            if (!(m < 1)) {
                for (t = 0; t < p; t++) {
                    for (r = (o = f[t % m]).rate, a = c[d + t], i = r === flock.rates.AUDIO ? 1 : 0, 
                    n = l = 0; n < e; n++, l += i) u = o.output[l], a[n] = a[n] + u;
                    g.mulAddFn(e, a, g.inputs.mul, g.inputs.add);
                }
                s.value = s.unscaledValue = u;
            }
        }, g.init = function() {
            g.sourceBuffers = [], g.onInputChanged();
        }, g.init(), g;
    }, flock.ugenDefaults("flock.ugen.out", {
        rate: "audio",
        inputs: {
            sources: null,
            bus: 0,
            expand: 2
        },
        ugenOptions: {
            tags: [ "flock.ugen.outputType" ],
            multiInputNames: [ "sources" ]
        }
    }), flock.ugen.valueOut = function(e, t, n) {
        var o = flock.ugen(e, t, n);
        return o.arraySourceGen = function() {
            for (var e = o.model, t = o.inputs.sources, n = 0; n < t.length; n++) e.value[n] = t[n].output[0];
        }, o.ugenSourceGen = function() {
            o.model.value = o.model.unscaledValue = o.inputs.sources.output[0];
        }, o.onInputChanged = function() {
            var e = o.model, t = o.inputs.sources;
            flock.isIterable(t) ? (o.gen = o.arraySourceGen, e.value = new Float32Array(t.length), 
            e.unscaledValue = e.value) : o.gen = o.ugenSourceGen;
        }, o.onInputChanged(), o;
    }, flock.ugenDefaults("flock.ugen.valueOut", {
        rate: "control",
        inputs: {
            sources: null
        },
        ugenOptions: {
            model: {
                unscaledValue: null,
                value: null
            },
            tags: [ "flock.ugen.outputType", "flock.ugen.valueType" ]
        }
    }), flock.ugen.in = function(e, t, n) {
        var u = flock.ugen(e, t, n);
        return u.singleBusGen = function(e) {
            var t = u.model, n = u.output;
            flock.ugen.in.readBus(e, n, u.inputs.bus, u.options.buses), t.unscaledValue = flock.ugen.lastOutputValue(e, n), 
            u.mulAdd(e), t.value = flock.ugen.lastOutputValue(e, n);
        }, u.multiBusGen = function(e) {
            for (var t, n, o = u.model, r = u.inputs.bus, a = u.options.buses, i = u.output, l = 0; l < e; l++) {
                for (t = n = 0; t < r.length; t++) n += a[0 | r[t].output[0]][l];
                i[l] = n;
            }
            o.unscaledValue = n, u.mulAdd(e), o.value = flock.ugen.lastOutputValue(e, i);
        }, u.onInputChanged = function() {
            u.gen = flock.isIterable(u.inputs.bus) ? u.multiBusGen : u.singleBusGen, 
            flock.onMulAddInputChanged(u);
        }, u.onInputChanged(), u;
    }, flock.ugen.in.readBus = function(e, t, n, o) {
        for (var r = o[0 | n.output[0]], a = 0; a < e; a++) t[a] = r[a];
    }, flock.ugenDefaults("flock.ugen.in", {
        rate: "audio",
        inputs: {
            bus: 0,
            mul: null,
            add: null
        }
    }), flock.ugen.audioIn = function(e, t, n) {
        var i = flock.ugen(e, t, n);
        return i.gen = function(e) {
            for (var t, n = i.model, o = i.output, r = i.bus, a = 0; a < e; a++) o[a] = t = r[a];
            n.unscaledValue = t, i.mulAdd(e), n.value = flock.ugen.lastOutputValue(e, o);
        }, i.onInputChanged = function() {
            flock.onMulAddInputChanged(i);
        }, i.init = function() {
            var e = i.enviro.audioSystem.inputDeviceManager.openAudioDevice(n);
            i.bus = i.options.buses[e], i.onInputChanged();
        }, i.init(), i;
    }, flock.ugenDefaults("flock.ugen.audioIn", {
        rate: "audio",
        inputs: {
            mul: null,
            add: null
        }
    });
}();